//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Text;

namespace Bon.IEPG
{
	/// <summary>
	/// iEPGf[^̃p[T[C^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("3D752D7C-7080-486b-A59A-AF238CB4DB71")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	public interface IIEPGParser : IEnumerable
	{
		/// <summary>
		/// ftHg̃GR[fBO擾Eݒ肵܂B
		/// </summary>
		/// <remarks>ftHg̓VtgJISłB
		/// Xg[ɑ݂Content-Type𖳎Ă邽߁ÃvpeBŃGR[fBOw肷Kvꍇ܂B</remarks>
		Encoding DefaultEncoding
		{
			get;
			set;
		}

		/// <summary>
		/// p[Xς̃ACe擾܂B
		/// </summary>
		int Count
		{
			get;
		}

		/// <summary>
		/// p[Xς̃ACe擾܂B
		/// </summary>
		/// <param name="index">CfbNX</param>
		/// <returns>ACe</returns>
		IIEPGItem this[int index]
		{
			get;
		}

		/// <summary>
		/// Xe[Vϊ鎫ǉ܂B
		/// </summary>
		/// <param name="stationName">iEPG̃Xe[VɎw肳閼O</param>
		/// <param name="stationV2Name">iEPGo[W2̃Xe[VɎw肳u[hLXg+T[rXID</param>
		/// <remarks>iEPGo[W1̃Xe[Vɂ͌ȋK肪܂B
		/// ̂߁Â܂܂ŃT[rXIDoȂꍇ܂B
		/// ̂悤ȏꍇÃ\bhgpāAϊo^ĂKv܂B
		/// <para>Fparser.AddStation("mgjnCrW", "BSDT103");</para>
		/// ȂAo[W2̏ꍇ͏߂T[rXID肳Ă邽߁A肠܂B</remarks>
		void AddStation(string stationName, string stationV2Name);

		/// <summary>
		/// COM IStreamC^[tFCXgpăp[X܂B
		/// </summary>
		/// <param name="stream">IStreamC^[tFCX̃CX^X</param>
		void Parse(IStream stream);

		/// <summary>
		/// StreamNX̃CX^Xgpăp[X܂B
		/// </summary>
		/// <param name="stream">StreamNX̃CX^X</param>
		void Parse(Stream stream);

		/// <summary>
		/// TextReaderNX̃CX^Xgpăp[X܂B
		/// </summary>
		/// <param name="reader">TextReaderNX̃CX^X</param>
		/// <remarks>̃I[o[[hgpꍇADefaultEncodingvpeB͖܂B</remarks>
		void Parse(TextReader reader);
	}
}
