//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// [gQƂŃXg[̃vOEPGi[ReiC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("93098A2C-8D3A-4ca7-9B1A-6CCAEAE7F316")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRemoteProgramInformation
	{
		/// <summary>
		/// T[rXID擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("Service ID.")]
		int ServiceID
		{
			get;
		}

		/// <summary>
		/// f̃vOID擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("Program's video ID.")]
		int ProgramVideoID
		{
			get;
		}

		/// <summary>
		/// ̃vOID擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("Program's audio ID.")]
		int ProgramAudioID
		{
			get;
		}

		/// <summary>
		/// PCR̃vOID擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("Program's PCR ID.")]
		int ProgramPcrID
		{
			get;
		}

		/// <summary>
		/// T[rX擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("Program's service name.")]
		string ServiceName
		{
			get;
		}

		///////////////////////////////

		/// <summary>
		/// Ɏ擾\ȃvpeBl擾܂B
		/// </summary>
		[Category("Program Information")]
		[Description("This information completion status.")]
		EpgDataStates EpgDataStatus
		{
			get;
		}

		///////////////////////////////
		// EventIDStored ŗL

		/// <summary>
		/// vOID擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		[Category("Event ID")]
		[Description("Program ID.")]
		int ProgramID
		{
			get;
		}

		/// <summary>
		/// Jn擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		[Category("Event ID")]
		[Description("Program's start time.")]
		DateTime StartTime
		{
			get;
		}

		/// <summary>
		/// Xg[̎ԊԊu擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		[Category("Event ID")]
		[Description("Program's end time.")]
		DateTime EndTime
		{
			get;
		}

		/// <summary>
		/// XNuĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		[Category("Event ID")]
		[Description("Is program scrambled?")]
		bool IsScrambled
		{
			get;
		}

		///////////////////////////////
		// ShortInfoStored ŗL

		/// <summary>
		/// Cxg^Cg擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusShortInfoStoredĂKv܂B</remarks>
		[Category("Short Information")]
		[Description("Program's title.")]
		string EventTitle
		{
			get;
		}

		/// <summary>
		/// Cxg擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusShortInfoStoredĂKv܂B</remarks>
		[Category("Short Information")]
		[Description("Program's information.")]
		string EventInfo
		{
			get;
		}

		///////////////////////////////
		// ExtendInfoStored ŗL

		/// <summary>
		/// Cxg̏ڍׂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusExtendInfoStoredĂKv܂B</remarks>
		[Category("Extend Information")]
		[Description("Program's information. (Detail)")]
		string EventDetail
		{
			get;
		}

		///////////////////////////////
		// VideoInfoStored ŗL

		/// <summary>
		/// f̑擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		[Category("Video Information")]
		[Description("Program's video vertical resolution.")]
		int VideoResolution
		{
			get;
		}

		/// <summary>
		/// fvObVuǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		[Category("Video Information")]
		[Description("Is program video with progressive scan?")]
		bool IsVideoProgressive
		{
			get;
		}

		/// <summary>
		/// fCh䗦ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		[Category("Video Information")]
		[Description("Is program video with wide aspect ratio?")]
		bool IsVideoAspectWide
		{
			get;
		}

		/// <summary>
		/// fpXLĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		[Category("Video Information")]
		[Description("Is program video with pan and scan?")]
		bool IsVideoPanAndScan
		{
			get;
		}

		///////////////////////////////
		// AudioInfoStored ŗL

		/// <summary>
		/// ̏擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusAudioInfoStoredĂKv܂B</remarks>
		[Category("Audio Information")]
		[Description("Program's audio mode.")]
		AudioModes AudioMode
		{
			get;
		}

		///////////////////////////////
		// ContentInfoStored ŗL

		/// <summary>
		/// W擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusContentInfoStoredĂKv܂B</remarks>
		[Category("Content Information")]
		[Description("Program's genre code.")]
		int Genre
		{
			get;
		}
	}
}
