//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Net;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

namespace Bon.Remoting
{
	/// <summary>
	/// NCAgŎgpoA[gQƂ擾NXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("0110D48F-A7D4-4ac2-A5D5-7B4681E87F16")]
	[ComDefaultInterface(typeof(IRemoteStreamService))]
	public sealed class RemoteStreamService : IRemoteStreamService
	{
		private static readonly object lock_ = new object();
		private static int count_;
		private static HttpClientChannel channel_;
		private bool disposed_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		public RemoteStreamService()
		{
			lock (lock_)
			{
				// AvP[VhCň̃CX^XL
				count_++;
				if (count_ == 1)
				{
					// [eBO`lL
					Hashtable properties = new Hashtable();
					properties["timeout"] = 10000;
					properties["credentials"] = CredentialCache.DefaultNetworkCredentials;
					properties["includeVersions"] = true;
					properties["allowAutoRedirect"] = true;
					channel_ = new HttpClientChannel(properties, null);
					ChannelServices.RegisterChannel(channel_, false);
				}
			}
		}

		/// <summary>
		/// t@CiCUłB
		/// </summary>
		~RemoteStreamService()
		{
			Dispose();
		}

		/// <summary>
		/// Dispose\bhłB
		/// </summary>
		public void Dispose()
		{
			GC.SuppressFinalize(this);
			lock (lock_)
			{
				if (disposed_ == false)
				{
					count_--;
					if (count_ == 0)
					{
						ChannelServices.UnregisterChannel(channel_);
						channel_ = null;
					}
				}
				disposed_ = true;
			}
		}

		/// <summary>
		/// `[i[RNVURI擾܂B
		/// </summary>
		public static string TunerCollectionUri
		{
			get
			{
				return "TunerCollection.rem";
			}
		}

		/// <summary>
		/// R[_[URI擾܂B
		/// </summary>
		public static string RecorderUri
		{
			get
			{
				return "Recorder.rem";
			}
		}

		private static T CreateRemoteReference<T>(IUrl streamServiceBaseUrl, string uri)
		{
			if (streamServiceBaseUrl.AbsolutePath.EndsWith("/") == false)
			{
				return (T)Activator.GetObject(typeof(T), string.Format("{0}/{1}", streamServiceBaseUrl, uri));
			}
			else
			{
				return (T)Activator.GetObject(typeof(T), string.Format("{0}{1}", streamServiceBaseUrl, uri));
			}
		}

		/// <summary>
		/// `[i[RNVւ̃[gQƂ擾܂B
		/// </summary>
		/// <param name="streamServiceBaseUrl">Xg[T[rX̃x[XURL</param>
		/// <remarks>`[i[RNVւ̃[gQ</remarks>
		/// <remarks>x[XURL"http://localhost:26110/stream/"̂悤Ȍ`łB</remarks>
		public IRemoteTunerCollection GetTunerCollection(IUrl streamServiceBaseUrl)
		{
			return CreateRemoteReference<IRemoteTunerCollection>(streamServiceBaseUrl, TunerCollectionUri);
		}

		/// <summary>
		/// R[_[ւ̃[gQƂ擾܂B
		/// </summary>
		/// <param name="streamServiceBaseUrl">Xg[T[rX̃x[XURL</param>
		/// <remarks>R[_[ւ̃[gQ</remarks>
		/// <remarks>x[XURL"http://localhost:26110/stream/"̂悤Ȍ`łB</remarks>
		public IRemoteRecorder GetRecorder(IUrl streamServiceBaseUrl)
		{
			return CreateRemoteReference<IRemoteRecorder>(streamServiceBaseUrl, RecorderUri);
		}
	}
}
