//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.IO;
using System.Net;
using System.Threading;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace Bon.Remoting
{
	/// <summary>
	/// Xg[T[rXzMXg[ɐڑNXłB
	/// </summary>
	/// <remarks>̃NX𒼐ڃXg[ƂĎgpo܂B܂COMIStreamĂ܂B
	/// Xg[͓̎ǂݎ݂̂łBV[N⃉Cg̓T|[gĂ܂B</remarks>
	[ComVisible(true)]
	[Guid("A45D0C23-F593-40a2-B76D-8F02AFA314B2")]
	[ComDefaultInterface(typeof(IStreamClient))]
	public sealed class StreamClient : Stream, IStreamClient
	{
		private HttpWebRequest webRequest_;
		private HttpWebResponse webResponse_;
		private IStreamEndPoint localEndPoint_;
		private Stream stream_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		public StreamClient()
		{
		}

		/// <summary>
		/// Xg[T[rXɐڑ܂B
		/// </summary>
		/// <param name="url">Xg[T[rXURL</param>
		/// <param name="tuningSpace">`[jOXy[Xԍ</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <param name="programID">vOID</param>
		/// <param name="connectTimeout">ڑ̃^CAEgԁi~bj</param>
		/// <param name="streamTimeout">Xg[M̃^CAEgԁi~bj</param>
		/// <param name="locked">`[i[bNꍇtrue</param>
		/// <param name="userAgent">ڑɎgp郆[U[G[WFg</param>
		/// <remarks>`[jOXy[X̓`l-1̏ꍇ͖wƂȂAݑIǂĂ`lgp܂B
		/// T[rXIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IĎM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B
		/// vOIDƂ-1w肷ƁAvǑos܂B
		/// vOIDw肵ꍇ͈vvOoÃf[^M܂B</remarks>
		public void Connect(IUrl url, int tuningSpace, int channel, int serviceID, int programID,
			int connectTimeout, int streamTimeout, bool locked, string userAgent)
		{
			string targetUrl = null;
			if ((tuningSpace >= 0) && (channel >= 0))
			{
				targetUrl = string.Format("{0}?tuningSpace={1}&channel={2}&serviceID={3}&programID={4}&locked={5}",
					url, tuningSpace, channel, serviceID, programID, locked);
			}
			else
			{
				targetUrl = string.Format("{0}?serviceID={1}&programID={2}&locked={3}",
					url, serviceID, programID, locked);
			}

			webRequest_ = (HttpWebRequest)WebRequest.Create(targetUrl);
			webRequest_.ProtocolVersion = HttpVersion.Version11;
			webRequest_.Method = "GET";
			webRequest_.Credentials = CredentialCache.DefaultNetworkCredentials;
			webRequest_.AllowAutoRedirect = true;
			webRequest_.KeepAlive = false;
			webRequest_.Timeout = connectTimeout;
			webRequest_.ReadWriteTimeout = streamTimeout;
			webRequest_.UserAgent = userAgent;

			webResponse_ = (HttpWebResponse)webRequest_.GetResponse();
			if (webResponse_.StatusCode != HttpStatusCode.OK)
			{
				HttpStatusCode statusCode = webResponse_.StatusCode;
				webRequest_.Abort();
				webRequest_ = null;
				webResponse_ = null;
				throw new InvalidDataException(
					"Http response status code is not OK: StatusCode=" + statusCode);
			}

			try
			{
				string ipAddressString = webResponse_.Headers["X-IPAddress"];
				string portString = webResponse_.Headers["X-Port"];
				localEndPoint_ = new StreamEndPoint(new StreamAddress(ipAddressString), int.Parse(portString));
			}
			catch
			{
				Close();
				throw;
			}
		}

		/// <summary>
		/// Xg[N[Y܂B
		/// </summary>
		public override void Close()
		{
			if (webRequest_ != null)
			{
				webRequest_.Abort();
				webRequest_ = null;
				webResponse_ = null;
				stream_ = null;
			}
		}

		/// <summary>
		/// [JGh|Cg擾܂B
		/// </summary>
		public IStreamEndPoint LocalEndPoint
		{
			get
			{
				return localEndPoint_;
			}
		}

		public override bool CanRead
		{
			get
			{
				return true;
			}
		}

		public override bool CanSeek
		{
			get
			{
				return false;
			}
		}

		public override bool CanWrite
		{
			get
			{
				return false;
			}
		}

		public override bool CanTimeout
		{
			get
			{
				return true;
			}
		}

		/// <summary>
		/// Xg[tbV܂B
		/// </summary>
		public override void Flush()
		{
		}

		public override long Length
		{
			get
			{
				throw new InvalidOperationException("The method or operation is not implemented.");
			}
		}

		public override long Position
		{
			get
			{
				throw new InvalidOperationException("The method or operation is not implemented.");
			}
			set
			{
				throw new InvalidOperationException("The method or operation is not implemented.");
			}
		}

		/// <summary>
		/// ݂̃Xg[oCg V[PXǂݎAǂݎoCg̕Xg[̈ʒui߂܂B
		/// </summary>
		/// <param name="buffer">oCgzB̃\bh߂ƂAw肵oCgz offset  (offset + count -1) ܂ł̒lÃ݂\[XǂݎꂽoCgɒu܂B</param>
		/// <param name="offset">݂̃Xg[ǂݎf[^̊i[Jnʒu buffer ̃oCg ItZbgBCfbNXԍ 0 n܂܂B</param>
		/// <param name="count">݂̃Xg[ǂݎőoCgB</param>
		/// <returns>obt@ɓǂݎꂽvoCgBṽoCgǂݎ邱ƂłȂꍇA̒l͗voCg菬Ȃ܂B</returns>
		public override int Read(byte[] buffer, int offset, int count)
		{
			if (webResponse_ == null)
			{
				throw new InvalidOperationException("Stream not opened.");
			}
			if (stream_ == null)
			{
				stream_ = webResponse_.GetResponseStream();
			}
			return stream_.Read(buffer, offset, count);
		}

		public override IAsyncResult BeginRead(byte[] buffer, int offset, int count, AsyncCallback callback, object state)
		{
			if (webResponse_ == null)
			{
				throw new InvalidOperationException("Stream not opened.");
			}
			if (stream_ == null)
			{
				stream_ = webResponse_.GetResponseStream();
			}
			return stream_.BeginRead(buffer, offset, count, callback, state);
		}

		public override int EndRead(IAsyncResult asyncResult)
		{
			return stream_.EndRead(asyncResult);
		}

		public override IAsyncResult BeginWrite(byte[] buffer, int offset, int count, AsyncCallback callback, object state)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		public override void EndWrite(IAsyncResult asyncResult)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		public override long Seek(long offset, SeekOrigin origin)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		public override void SetLength(long value)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		public override void Write(byte[] buffer, int offset, int count)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		/// <summary>
		/// Xg[݂̌̃V[N |C^ʂ̃Xg[݂̌̃V[N |C^Ɏw肵oCgRs[܂B
		/// </summary>
		/// <param name="pstm">Rs[Xg[ւ̎QƁB</param>
		/// <param name="cb">Rs[Xg[Rs[oCgB</param>
		/// <param name="pcbRead">ɕԂꂽꍇ́ARs[ǂݎꂽۂ̃oCgi[܂B</param>
		/// <param name="pcbWritten">ɕԂꂽꍇ́ARs[ɏ܂ꂽۂ̃oCgi[܂B</param>
		public void CopyTo(IStream pstm, long cb, IntPtr pcbRead, IntPtr pcbWritten)
		{
			long readPosition = 0;
			long writePosition = 0;
			byte[] buffer = new byte[65536];
			IntPtr temp = Marshal.AllocHGlobal(sizeof(int));
			try
			{
				while (readPosition < cb)
				{
					int read = Read(buffer, 0, buffer.Length);
					if (read == 0)
					{
						break;
					}
					readPosition += read;
					pstm.Write(buffer, read, temp);
					int written = Marshal.ReadInt32(temp);
					if (written != read)
					{
						throw new IOException("Copy failed.");
					}
					writePosition += written;
				}
			}
			finally
			{
				Marshal.FreeHGlobal(temp);
			}
			Marshal.WriteInt64(pcbRead, readPosition);
			Marshal.WriteInt64(pcbWritten, writePosition);
		}

		/// <summary>
		/// ݂̃V[N |C^Jn_ƂāAXg[ IuWFNg烁Ɏw肵oCgǂݎ܂B
		/// </summary>
		/// <param name="pv">̃\bhԂƂɁAXg[ǂݎꂽf[^i[܂B̃p[^͏ɓn܂B</param>
		/// <param name="cb">Xg[ IuWFNgǂݎoCgB</param>
		/// <param name="pcbRead">Xg[ IuWFNgǂݎꂽۂ̃oCg󂯎 ULONG ϐւ̃|C^B</param>
		public void Read(byte[] pv, int cb, IntPtr pcbRead)
		{
			int read = Read(pv, 0, cb);
			Marshal.WriteInt32(pcbRead, read);
		}

		#region IStream o
		void IStream.Clone(out IStream ppstm)
		{
			throw new Exception("The method or operation is not implemented.");
		}

		void IStream.Commit(int grfCommitFlags)
		{
		}

		void IStream.LockRegion(long libOffset, long cb, int dwLockType)
		{
		}

		void IStream.Revert()
		{
		}

		void IStream.Seek(long dlibMove, int dwOrigin, IntPtr plibNewPosition)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		void IStream.SetSize(long libNewSize)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		void IStream.Stat(out System.Runtime.InteropServices.ComTypes.STATSTG pstatstg, int grfStatFlag)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		void IStream.UnlockRegion(long libOffset, long cb, int dwLockType)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}

		void IStream.Write(byte[] pv, int cb, IntPtr pcbWritten)
		{
			throw new InvalidOperationException("The method or operation is not implemented.");
		}
		#endregion
	}
}
