//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Globalization;
using System.Net;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// IPAhXNXłB
	/// </summary>
	[Serializable]
	[ComVisible(true)]
	[Guid("40F02148-BF8D-40c6-8764-DC19A7745E6C")]
	[ComDefaultInterface(typeof(IStreamAddress))]
	[TypeConverter(typeof(StreamAddressConverter))]
	public sealed class StreamAddress : IPAddress, IStreamAddress
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <remarks>[vobNAhXɏ܂B</remarks>
		public StreamAddress()
			: base(IPAddress.Loopback.GetAddressBytes())
		{
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="address">IPAhX</param>
		public StreamAddress(string address)
			: base(IPAddress.Parse(address).GetAddressBytes())
		{
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="address">IPAhX</param>
		public StreamAddress(IPAddress address)
			: base(address.GetAddressBytes())
		{
		}

		/// <summary>
		/// IPAhX̕\AhX擾܂B
		/// </summary>
		/// <param name="address">IPAhX̕\</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public IStreamAddress CreateFromString(string address)
		{
			return new StreamAddress(address);
		}
	}

	/// <summary>
	/// IP AhXƃ|[gԍŃlbg[N Gh|Cg\NXłB
	/// </summary>
	[Serializable]
	[ComVisible(true)]
	[Guid("F819B7B5-5B8B-4345-8894-E0C73366399D")]
	[ComDefaultInterface(typeof(IStreamEndPoint))]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public sealed class StreamEndPoint : IPEndPoint, IStreamEndPoint
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <remarks>[vobNAhXƃ|[gԍ0ɏ܂B</remarks>
		public StreamEndPoint()
			: base(new StreamAddress(), 0)
		{
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="address">AhX</param>
		/// <param name="port">|[gԍ</param>
		public StreamEndPoint(IStreamAddress address, int port)
			: base((IPAddress)address, port)
		{
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="endPoint">Gh|Cg</param>
		public StreamEndPoint(IPEndPoint endPoint)
			: base(new StreamAddress(endPoint.Address), endPoint.Port)
		{
		}

		/// <summary>
		/// Gh|Cg IP AhX擾܂͐ݒ肵܂B
		/// </summary>
		public new IStreamAddress Address
		{
			get
			{
				return (IStreamAddress)base.Address;
			}

			set
			{
				base.Address = (IPAddress)value;
			}
		}

		/// <summary>
		/// w肳ꂽGh|Cgǂ擾܂B
		/// </summary>
		/// <param name="endPoint">Gh|Cg</param>
		/// <returns>Ȃtrue</returns>
		public bool Equals(IStreamEndPoint endPoint)
		{
			return base.Equals(endPoint);
		}
	}

	/// <summary>
	/// StreamAddressƕ̑ݕϊsNXłB
	/// </summary>
	public sealed class StreamAddressConverter : TypeConverter
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		public StreamAddressConverter()
		{
		}

		public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
		{
			return ((sourceType == typeof(string)) || base.CanConvertFrom(context, sourceType));
		}

		public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
		{
			if (value is string)
			{
				return new StreamAddress((string)value);
			}
			if (value == null)
			{
				return new StreamAddress();
			}
			return base.ConvertFrom(context, culture, value);
		}

		public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
		{
			return ((destinationType == typeof(string)) || base.CanConvertTo(context, destinationType));
		}

		public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
		{
			if (destinationType == typeof(string))
			{
				return value.ToString();
			}
			return base.ConvertTo(context, culture, value, destinationType);
		}
	}
}
