//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Security.Permissions;

namespace Bon
{
	/// <summary>
	/// URLNXłB
	/// </summary>
	/// <remarks>̃NXUriNX̃bp[NXłB
	/// ܂AIUrlC^[tFCXĂ邽߁ACOMQƉ\łB</remarks>
	[Serializable]
	[TypeConverter(typeof(UriTypeConverter))]
	public sealed class Url : Uri, IUrl
	{
		public Url(string urlString)
			: base(urlString)
		{
		}

		[SecurityPermission(SecurityAction.LinkDemand, Flags = SecurityPermissionFlag.SerializationFormatter)]
		private Url(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}

		public Url(string urlString, UriKind urlKind)
			: base(urlString, urlKind)
		{
		}

		public Url(Uri baseUrl, string relativeUrl)
			: base(baseUrl, relativeUrl)
		{
		}

		public Url(Uri baseUrl, Uri relativeUrl)
			: base(baseUrl, relativeUrl)
		{
		}

		public bool Equals(IUrl url)
		{
			return base.Equals(url);
		}

		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

		public string AbsoluteUrl
		{
			get
			{
				return base.AbsoluteUri;
			}
		}

		public bool IsAbsoluteUrl
		{
			get
			{
				return base.IsAbsoluteUri;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public override bool Equals(object obj)
		{
			return Equals(obj as IUrl);
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public new string AbsoluteUri
		{
			get
			{
				return base.AbsoluteUri;
			}
		}

		[EditorBrowsable(EditorBrowsableState.Never)]
		public new bool IsAbsoluteUri
		{
			get
			{
				return base.IsAbsoluteUri;
			}
		}
	}

	/// <summary>
	/// IUrlC^[tFCX̃CX^X𐶐NXłB
	/// </summary>
	/// <remarks>COM璼IUrlC^[tFCX̃CX^X𐶐oȂ߁ÃNXgpĐ܂B</remarks>
	[ComVisible(true)]
	[Guid("20C3B681-ADD9-4cab-BDD5-D8D1CC45731D")]
	[ComDefaultInterface(typeof(IUrlBuilder))]
	public sealed class UrlBuilder : UriBuilder, IUrlBuilder
	{
		public UrlBuilder()
		{
		}

		public UrlBuilder(string uri)
			: base(uri)
		{
		}

		public UrlBuilder(Uri uri)
			: base(uri)
		{
		}

		public UrlBuilder(string schemeName, string hostName)
			: base(schemeName, hostName)
		{
		}

		public UrlBuilder(string scheme, string host, int portNumber)
			: base(scheme, host, portNumber)
		{
		}

		public UrlBuilder(string scheme, string host, int port, string pathValue)
			: base(scheme, host, port, pathValue)
		{
		}

		public UrlBuilder(string scheme, string host, int port, string path, string extraValue)
			: base(scheme, host, port, path, extraValue)
		{
		}

		[ComVisible(false)]
		[EditorBrowsable(EditorBrowsableState.Never)]
		public new IUrl Uri
		{
			get
			{
				return new Url(base.Uri.ToString());
			}
		}

		public IUrl Url
		{
			get
			{
				return new Url(base.Uri.ToString());
			}
		}
	}
}
