//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ChannelInformation.h"
#include "ServiceInformation.h"

namespace Bon
{
	ChannelInformation::ChannelInformation(System::String^ name)
		: name_(name), services_(gcnew array<ServiceInformation^>(0))
	{
	}

	ChannelInformation::ChannelInformation(ChannelInformation^ rhs)
		: name_(rhs->name_), services_(gcnew array<ServiceInformation^>(rhs->services_->Length))
	{
		for (int i = 0; i < services_->Length; i++)
		{
			services_[i] = rhs->services_[i]->Clone();
		}
	}

	int ChannelInformation::GetHashCode()
	{
		int result = name_->GetHashCode();
		for (int i = 0; i < services_->Length; i++)
		{
			result ^= services_[i]->GetHashCode();
		}
		return result;
	}

	void ChannelInformation::SetServices(array<ServiceInformation^>^ services)
	{
		services_ = services;
	}

	System::String^ ChannelInformation::Name::get()
	{
		return name_;
	}

	ChannelInformation^ ChannelInformation::Clone()
	{
		return gcnew ChannelInformation(this);
	}

	IChannelInformation^ ChannelInformation::InterfaceClone()
	{
		return gcnew ChannelInformation(this);
	}

	System::Object^ ChannelInformation::ObjectClone()
	{
		return gcnew ChannelInformation(this);
	}

	System::Collections::IEnumerator^ ChannelInformation::GetEnumerator()
	{
		return services_->GetEnumerator();
	}
}
