//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ManagedLock.h"
#include "DataQueueManager.h"
#include "DataQueue.h"
#include "TsData.h"

namespace Bon
{
	namespace Internal
	{
		DataQueueManager::DataQueueManager(int bufferSize)
			: queueList_(gcnew System::Collections::Generic::List<DataQueue^>()),
			recycleBuffers_(gcnew System::Collections::Generic::Stack<TsData^>())
		{
			data_ = gcnew TsData(this, bufferSize);
		}

		DataQueueManager::~DataQueueManager()
		{
			ManagedLock	lock(recycleBuffers_);

			if (data_ != nullptr)
			{
				for (int i = 0; i < queueList_->Count; i++)
				{
					queueList_->default::get(i)->Close();
				}

				queueList_->Clear();
				recycleBuffers_->Clear();

				data_ = nullptr;
			}
		}

		void DataQueueManager::RegisterQueue(DataQueue ^queue)
		{
			queueList_->Add(queue);
		}

		int DataQueueManager::UnregisterQueue(DataQueue^ queue)
		{
			queueList_->Remove(queue);
			return queueList_->Count;
		}

		void DataQueueManager::Clear()
		{
			for (int i = 0; i < queueList_->Count; i++)
			{
				queueList_->default::get(i)->Clear();
			}
		}

		void DataQueueManager::Enqueue(const BYTE *pData, DWORD dataSize)
		{
			// Ŏw肳f[^͔ɍׂTCYȂ̂ŁAõobt@ɓB
			// obt@TCY𒴂Ă܂ꍇ́Alߍ܂Ɍ݂̃TCY܂łƂ
			// L[ɓi}l[Wz̊g͏oȂAoƂĂptH[}X
			// ɉeƎv邽߁jB̌AVobt@ɓB
			// ɒP̂Ńobt@TCYf[^nꂽꍇ́A̎
			// e|obt@pӂĂ̂B

			while (true)
			{
				// obt@ɒǋLoΏI
				if (data_->Append(pData, dataSize) == true)
				{
					break;
				}

				// obt@Ƀf[^݂
				if (data_->Size > 0)
				{
					// f[^L[ɓ
					for (int i = 0; i < queueList_->Count; i++)
					{
						DataQueue^ queue = queueList_->default::get(i);
						data_->AddRef();
						queue->Enqueue(data_);
					}

					// obt@V
					ManagedLock lock(recycleBuffers_);
					if (recycleBuffers_->Count > 0)
					{
						// LbVĂobt@̍ėp
						data_ = recycleBuffers_->Pop();
					}
					else
					{
						// VKɊmۂ
						data_ = gcnew TsData(this, data_->BufferSize);
					}
				}

				// f[^TCYobt@̃TCYȂ
				if (static_cast<int>(dataSize) > data_->BufferSize)
				{
					// e|obt@f[^TCYɍ킹ėpӂAf[^L[ɓ
					TsData^ data = gcnew TsData(this, dataSize);
					data->Append(pData, dataSize);

					for (int i = 0; i < queueList_->Count; i++)
					{
						DataQueue^ queue = queueList_->default::get(i);
						data->AddRef();
						queue->Enqueue(data);
					}

					break;
				}
			}
		}

		void DataQueueManager::Enqueue(const BYTE *pData, DWORD dataSize, int programID)
		{
			// Ƃ₱Fi-1̈ӖقȂ̂ŒӁj
			// programID-1w肷ƁAvOʏԂƂĈB
			// ܂AIDataQueue.ProgramID==-1iAnyԁjƂȂĂ΂ǂ̂悤programID
			// f[^󂯓邪Aw肳ĂprogramIDƈvȂ󂯓ȂB

			while (true)
			{
				// obt@ɒǋLoΏI
				if (data_->Append(pData, dataSize) == true)
				{
					break;
				}

				// obt@Ƀf[^݂
				if (data_->Size > 0)
				{
					// f[^L[ɓ
					for (int i = 0; i < queueList_->Count; i++)
					{
						// vOIDw肳ĂȂAvOIDȂ
						DataQueue^ queue = queueList_->default::get(i);
						if ((queue->ProgramID == -1) || (programID == queue->ProgramID))
						{
							data_->AddRef();
							queue->Enqueue(data_);
						}
					}

					// obt@V
					ManagedLock lock(recycleBuffers_);
					if (recycleBuffers_->Count > 0)
					{
						// LbVĂobt@̍ėp
						data_ = recycleBuffers_->Pop();
					}
					else
					{
						// VKɊmۂ
						data_ = gcnew TsData(this, data_->BufferSize);
					}
				}

				// f[^TCYobt@̃TCYȂ
				if (static_cast<int>(dataSize) > data_->BufferSize)
				{
					// e|obt@f[^TCYɍ킹ėpӂAf[^L[ɓ
					TsData^ data = gcnew TsData(this, dataSize);
					data->Append(pData, dataSize);

					for (int i = 0; i < queueList_->Count; i++)
					{
						// vOIDw肳ĂȂAvOIDȂ
						DataQueue^ queue = queueList_->default::get(i);
						if ((queue->ProgramID == -1) || (programID == queue->ProgramID))
						{
							data_->AddRef();
							queue->Enqueue(data_);
						}
					}

					break;
				}
			}
		}

		void DataQueueManager::RecycleBuffer(TsData^ data)
		{
			ManagedLock	lock(recycleBuffers_);

			// 쒆Ȃ
			if (data_ != nullptr)
			{
				// ۑ
				recycleBuffers_->Push(data);
			}
		}

		System::Collections::Generic::IEnumerator<DataQueue^>^ DataQueueManager::GetEnumerator()
		{
			return queueList_->GetEnumerator();
		}

		System::Collections::IEnumerator^ DataQueueManager::IEnumerableGetEnumerator()
		{
			return queueList_->GetEnumerator();
		}
	}
}
