//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class DataQueue;
	ref class TsData;

	namespace Internal
	{
		ref class DataQueueManager sealed
			: public System::Collections::Generic::IEnumerable<DataQueue^>
		{
		private:
			TsData^ data_;
			initonly System::Collections::Generic::List<DataQueue^>^ queueList_;
			initonly System::Collections::Generic::Stack<TsData^>^ recycleBuffers_;

			virtual System::Collections::IEnumerator^ IEnumerableGetEnumerator() sealed =
				System::Collections::IEnumerable::GetEnumerator;

		internal:
			DataQueueManager(int bufferSize);

			void Enqueue(const BYTE *pData, DWORD dataSize);
			void Enqueue(const BYTE *pData, DWORD dataSize, int programID);
			void RecycleBuffer(TsData^ data);

		public:
			~DataQueueManager();
			void RegisterQueue(DataQueue^ queue);
			int UnregisterQueue(DataQueue^ queue);

			void Clear();

			virtual System::Collections::Generic::IEnumerator<DataQueue^>^ GetEnumerator();
		};
	}
}
