//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class DataQueue;
	ref class Tuner;

	namespace Internal
	{
		ref class DataQueueManager;

		class StreamSink : public CMediaDecoder
		{
		private:
			const IProgAnalyzer *pProgAnalyzer_;
			const DWORD bufferSize_;
			int queueCount_;
			gcroot<System::Collections::Generic::Dictionary<int, DataQueueManager^>^> managerList_;
			BYTE programIDVersion_;

			void InternalAddQueue(DataQueue^ queue, int serviceID);
			void InternalRemoveQueue(DataQueue^ queue, int serviceID);

			virtual const bool OnPlay();
			virtual const bool OnStop();
			virtual const bool OnReset();
			virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

			StreamSink(const StreamSink &);
			void operator =(const StreamSink &);

		public:
			StreamSink(IBonObject *pOwner = 0, DWORD bufferSize = 512 * 1024);
			~StreamSink();

			DECLARE_IBONOBJECT(StreamSink)

			int GetCount() const;
			void Clear();

			System::Collections::Generic::KeyValuePair<IDataQueue^, int>
				CreateQueue(Tuner^ parent, int serviceID, int programID, __int64 maxSize, bool locked);

			void ChangeServiceID(DataQueue^ queue, int newServiceID);
			void ChangeServiceIDForAllQueue(int newServiceID);

			int RemoveQueue(DataQueue^ queue);

		};
	}
}
