//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	namespace Internal
	{
		class StreamSink;

		ref class MediaDecoderEventArgs;
		class MediaDecoderHandlerTrampoline;
	}

	ref class DataQueue;
	ref class TuningSpaceInformation;

	/// <summary>
	/// `[i[NXłB
	/// </summary>
	ref class Tuner sealed
		: public ITuner
	{
	private:
		initonly ITunerDefinition^ tunerDefinition_;
		ITsSourceTuner *pTsSourceTuner_;
		ITsPacketSync *pTsPacketSync_;
		IProgAnalyzer *pProgAnalyzer_;
		ITsDescrambler *pTsDescrambler_;
		Internal::StreamSink *pStreamSink_;
		Internal::MediaDecoderHandlerTrampoline *pTsPacketSyncTrampoline_;
		Internal::MediaDecoderHandlerTrampoline *pTsDescramblerTrampoline_;
		initonly System::Collections::Generic::List<IPacketSyncEvent^>^ packetSyncEvents_;
		initonly System::Collections::Generic::List<IDescrambleEvent^>^ descrambleEvents_;
		System::Guid lockCookie_;
		bool running_;
		bool enableEmmProcess_;
		bool enableLnbPower_;

		void OnTsPacketSyncEvent(Internal::MediaDecoderEventArgs^ e);
		void OnTsDescramblerEvent(Internal::MediaDecoderEventArgs^ e);

		void ScanService(int count);
		void ScanChannelEntry(System::Object^ dummy);

	internal:
		Tuner(ITunerDefinition^ tunerDefinition, System::String^ casCardReader);

		void ChangeServiceID(DataQueue^ queue, int newServiceID);
		void RemoveQueue(DataQueue^ queue);

	public:
		/// <summary>
		/// Finalizer\bhłB
		/// </summary>
		!Tuner();

		/// <summary>
		/// Dispose\bhłB
		/// </summary>
		~Tuner();

		/// <summary>
		/// `[i[擾܂B
		/// </summary>
		/// <remarks>`[i[BonSDK̃`[i[NXłB
		/// Ⴆ΍FriioȂA"CBonBlackTuner"Ԃ܂B</remarks>
		property System::String^ TunerName
		{
			virtual System::String^ get();
		}

		/// <summary>
		/// foCX擾܂B
		/// </summary>
		/// <remarks>foCX̓`[i[NX瓾ꂽ[U[ǉ\ȕłB</remarks>
		property System::String^ DeviceName
		{
			virtual System::String^ get();
		}

		/// <summary>
		/// ̃`[i[M\ȃ`[jOXy[Xƃ`l̏擾܂B
		/// </summary>
		property array<ITuningSpaceInformation^>^ TuningSpaces
		{
			virtual array<ITuningSpaceInformation^>^ get();
		}

		/// <summary>
		/// foCXID擾܂B
		/// </summary>
		/// <remarks>ނ̃`[i[݂ꍇɁAقȂlԂ܂B</remarks>
		property int DeviceID
		{
			virtual int get();
		}

		/// <summary>
		/// `[i[̃bNԂ擾܂B
		/// </summary>
		property bool IsLocked
		{
			virtual bool get();
		}

		/// <summary>
		/// `[i[AbN܂B
		/// </summary>
		/// <param name="cookie">bNNbL[</param>
		virtual void Unlock(System::Guid cookie);

		/// <summary>
		/// `[i[ғǂ擾܂B
		/// </summary>
		property bool IsRunning
		{
			virtual bool get();
		}

		/// <summary>
		/// J[hID擾܂B
		property array<System::Byte>^ CardID
		{
			virtual array<System::Byte>^ get();
		}

		/// <summary>
		/// J[hɑ΂EMMKp邩ǂ擾Eݒ肵܂B
		/// </summary>
		property bool EnableEmmProcess
		{
			virtual bool get();
			virtual void set(bool value);
		}

		/// <summary>
		/// `[i[ɐڑĂAeipLNBdL邩ǂ擾Eݒ肵܂B
		/// </summary>
		property bool EnableLnbPower
		{
			virtual bool get();
			virtual void set(bool value);
		}

		/// <summary>
		/// `[i[ɐڑĂAeǐ݂̎Mx擾܂B
		/// </summary>
		property float SignalLevel
		{
			virtual float get();
		}

		/// <summary>
		/// ݑIĂ`[jOXy[X擾܂B
		/// </summary>
		/// <remarks>`[jOXy[Xƃ`l̗̏𓾂ꍇA
		/// ̃vpeBgpƐʂȂ\܂B
		/// 𓾂邽߂ɂ́ÃvpeBł͂ȂGetChannel\bhgp܂B</remarks>
		property int TuningSpace
		{
			virtual int get();
		}

		/// <summary>
		/// ݑIĂ`l擾܂B
		/// </summary>
		/// <remarks>`[jOXy[Xƃ`l̗̏𓾂ꍇA
		/// ̃vpeBgpƐʂȂ\܂B
		/// 𓾂邽߂ɂ́ÃvpeBł͂ȂGetChannel\bhgp܂B</remarks>
		property int Channel
		{
			virtual int get();
		}

		/// <summary>
		/// ݑIĂ`[jOXy[Xƃ`l擾܂B
		/// </summary>
		virtual ISelectedChannel^ GetChannel();

		/// <summary>
		/// ̃`[i[̃`[jOXy[Xƃ`lݒ肵܂B
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <remarks>CreateQueueŐSẴL[́AIɎw肳ꂽT[rXIDɕύX܂
		/// iAA`[jOXy[Xƃ`lɕύXȂꍇ͖܂jB
		/// T[rXIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IđM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B</remarks>
		virtual void SetChannel(int tuningSpace, int channel, int serviceID);

		/// <summary>
		/// ̃`[i[̃`[jOXy[Xƃ`lݒ肵܂B
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <returns>bNNbL[</returns>
		/// <remarks>`[i[bNƁAEnableEmmProcess, EnableLnbPowerւ̐ݒA
		/// SetChannel, SetChannelWithLockoȂȂ܂B
		/// bNNbL[gpUnlockĂяoȂƉ񕜂Ȃ߁AӂKvłB</remarks>
		virtual System::Guid SetChannelWithLock(int tuningSpace, int channel, int serviceID);

		/// <summary>
		/// ݎM̃Xg[̃lbg[NID擾܂B
		/// </summary>
		property int NetworkID
		{
			virtual int get();
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[N擾܂B
		/// </summary>
		property System::String^ NetworkName
		{
			virtual System::String^ get();
		}

		/// <summary>
		/// ݎM̃Xg[̃gX|[gXg[ID擾܂B
		/// </summary>
		property int TransportStreamID
		{
			virtual int get();
		}

		/// <summary>
		/// ݎM̃Xg[̊Jn擾܂B
		/// </summary>
		property System::DateTime StreamTime
		{
			virtual System::DateTime get();
		}

		/// <summary>
		/// ݎMĂEPG擾܂B
		/// </summary>
		property array<IProgramInformation^>^ Programs
		{
			virtual array<IProgramInformation^>^ get();
		}

		/// <summary>
		/// XNȕԂ擾܂B
		/// </summary>
		property DescramblingStates DescramblingStatus
		{
			virtual DescramblingStates get();
		}

		/// <summary>
		/// ̃`[i[MĂXg[擾邽߂̃L[𐶐܂B
		/// </summary>
		/// <param name="serviceID">Xg[̃T[rX肷T[rXID</param>
		/// <param name="programID">Xg[̃vO肷vOID</param>
		/// <param name="maxSize">L[ɕێXg[̍őoCg</param>
		/// <param name="locked">T[rXID̕ύXp[WȂꍇtrue</param>
		/// <returns>L[</returns>
		/// <remarks>T[rXIDƂ-1w肷ƁASẴXg[f[^L[ɒ~ς܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IĒ~ς܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B
		/// vOIDƂ-1w肷ƁAvǑos܂B
		/// vOIDw肵ꍇ͈vvOoÃf[^~ς܂B
		/// Xg[f[^͑傫߁AőoCg傫Ȓlw肷Kv܂B
		/// L[ɒ~ςꂽf[^̃oCg𒴂ƁAL[̃f[^Iɔj܂B</remarks>
		virtual IDataQueue^ CreateQueue(int serviceID, int programID, __int64 maxSize, bool locked);

		/// <summary>
		/// CxgVNo^܂B
		/// </summary>
		/// <param name="packetSync">IPacketSyncEventCX^X</param>
		virtual void RegisterEvent(IPacketSyncEvent^ packetSync);

		/// <summary>
		/// CxgVNo^܂B
		/// </summary>
		/// <param name="descramble">IDescrambleEventCX^X</param>
		virtual void RegisterEvent(IDescrambleEvent^ descramble);

		/// <summary>
		/// CxgVN̓o^܂B
		/// </summary>
		/// <param name="packetSync">IPacketSyncEventCX^X</param>
		virtual void UnregisterEvent(IPacketSyncEvent^ packetSync);

		/// <summary>
		/// CxgVN̓o^܂B
		/// </summary>
		/// <param name="descramble">IDescrambleEventCX^X</param>
		virtual void UnregisterEvent(IDescrambleEvent^ descramble);
	};
}
