//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "TuningSpaceInformation.h"
#include "ChannelInformation.h"

namespace Bon
{
	TuningSpaceInformation::TuningSpaceInformation(System::String^ name, array<ChannelInformation^>^ channels)
		: name_(name), channels_(gcnew array<ChannelInformation^>(channels->Length))
	{
		for (int i = 0; i < channels_->Length; i++)
		{
			channels_[i] = channels[i]->Clone();
		}
	}

	TuningSpaceInformation::TuningSpaceInformation(TuningSpaceInformation^ rhs)
		: name_(rhs->name_), channels_(gcnew array<ChannelInformation^>(rhs->channels_->Length))
	{
		for (int i = 0; i < channels_->Length; i++)
		{
			channels_[i] = rhs->channels_[i]->Clone();
		}
	}

	int TuningSpaceInformation::GetHashCode()
	{
		int result = name_->GetHashCode();
		for (int i = 0; i < channels_->Length; i++)
		{
			result ^= channels_[i]->GetHashCode();
		}
		return result;
	}

	void TuningSpaceInformation::SetServices(int channel, array<ServiceInformation^>^ services)
	{
		channels_[channel]->SetServices(services);
	}

	System::String^ TuningSpaceInformation::Name::get()
	{
		return name_;
	}

	TuningSpaceInformation^ TuningSpaceInformation::Clone()
	{
		return gcnew TuningSpaceInformation(this);
	}

	ITuningSpaceInformation^ TuningSpaceInformation::InterfaceClone()
	{
		return gcnew TuningSpaceInformation(this);
	}

	System::Object^ TuningSpaceInformation::ObjectClone()
	{
		return gcnew TuningSpaceInformation(this);
	}

	System::Collections::IEnumerator^ TuningSpaceInformation::GetEnumerator()
	{
		return channels_->GetEnumerator();
	}
}
