//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using Bon.Remoting;
using Bon.IEPG;

namespace Bon
{
	/// <summary>
	/// vO\tH[łB
	/// </summary>
	internal partial class RegisterIEPGForm : Form, IEnumerable<IInputProgramInformation>
	{
		private delegate void AddStreamServiceEntryDelegate(TreeNode streamServiceNode);
		private delegate void AddTunerEntryDelegate(TreeNode streamServiceNode, TreeNode tunerNode);

		private readonly List<RegisterIEPGControl> controls_ = new List<RegisterIEPGControl>();

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tags">ǗĂSẴ^OQ</param>
		/// <param name="tvpidStream">iEPGXg[</param>
		public RegisterIEPGForm(IEnumerable<StreamServiceTag> tags, Stream tvpidStream)
		{
			InitializeComponent();

			IIEPGParser parser = new IEPGParser();
			parser.Parse(tvpidStream);

			foreach (IIEPGItem item in parser)
			{
				string tabName = (item.ProgramID != -1) ?
					string.Format("Program [{0}]", item.ProgramID) : string.Format("Program {0}", controls_.Count);
				TabPage tabPage = new TabPage(tabName);

				RegisterIEPGControl control = new RegisterIEPGControl(this, tags, item);
				control.Dock = DockStyle.Fill;

				tabPage.Controls.Add(control);
				tabControl.TabPages.Add(tabPage);

				controls_.Add(control);
			}
		}

		/// <summary>
		/// {^̏ԂύX܂B
		/// </summary>
		/// <remarks>e͂ꍇOK{^悤ɂ܂B</remarks>
		public void UpdateButton()
		{
			bool required = false;
			for (int i = 0; i < controls_.Count; i++)
			{
				RegisterIEPGControl control = controls_[i];
				if (control.RequireRegist == true)
				{
					required = true;

					if (control.IsValid == false)
					{
						okButton.Enabled = false;
						return;
					}
				}
			}

			okButton.Enabled = required;
		}

		/// <summary>
		/// iEPGXg[Ɋ܂܂Ă郌R[h擾܂B
		/// </summary>
		public int Count
		{
			get
			{
				return controls_.Count;
			}
		}

		/// <summary>
		/// w肳ꂽR[h̓͂Lǂ擾܂B
		/// </summary>
		/// <param name="index"></param>
		/// <returns></returns>
		public bool IsValid(int index)
		{
			return controls_[index].RequireRegist && controls_[index].IsValid;
		}

		/// <summary>
		/// ͂ꂽvO擾܂B
		/// </summary>
		/// <param name="index">ʒu</param>
		/// <returns>vO</returns>
		public IInputProgramInformation this[int index]
		{
			get
			{
				return controls_[index];
			}
		}

		/// <summary>
		/// ͂ꂽvO񋓂܂B
		/// </summary>
		/// <returns>񋓎q</returns>
		public IEnumerator<IInputProgramInformation> GetEnumerator()
		{
			List<IInputProgramInformation> list = new List<IInputProgramInformation>();
			for (int i = 0; i < controls_.Count; i++)
			{
				if (IsValid(i) == true)
				{
					list.Add(this[i]);
				}
			}
			return list.GetEnumerator();
		}

		/// <summary>
		/// ͂ꂽvO񋓂܂B
		/// </summary>
		/// <returns>񋓎q</returns>
		IEnumerator IEnumerable.GetEnumerator()
		{
			return GetEnumerator();
		}
	}
}