//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;

namespace Bon
{
	[Flags]
	internal enum ExecutionState : uint
	{
		SystemRequired = 1,
		DisplayRequired = 2,
		UserPresent = 4,
		Continuous = 0x80000000
	}

	internal static class ExecutionStateController
	{
		[DllImport("kernel32.dll")]
		private static extern ExecutionState SetThreadExecutionState(ExecutionState state);

		public static void SetState(ExecutionState state)
		{
			SetThreadExecutionState(state);
		}
	}
}
