﻿//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.ServiceProcess;

namespace Bon
{
	[DesignTimeVisible(false)]
	internal partial class StreamService : ServiceBase
	{
		private StreamManager manager_ = new StreamManager();

		public StreamService()
		{
			InitializeComponent();

			base.ServiceName = ServiceName;
		}

		protected override void Dispose(bool disposing)
		{
			if (manager_ != null)
			{
				manager_.Dispose();
				manager_ = null;
			}

			if (disposing && (components != null))
			{
				components.Dispose();
			}

			base.Dispose(disposing);
		}

		public static new string ServiceName
		{
			get
			{
				return "Bon.StreamService";
			}
		}

		protected override void OnStart(string[] args)
		{
			manager_.Start();
		}

		protected override void OnStop()
		{
			manager_.Stop();
		}
	}
}
