//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Runtime.Remoting.Lifetime;
using System.Security.Permissions;
using Bon.Remoting;

namespace Bon
{
	internal sealed class TunerCollectionFacade : MarshalByRefObject, IRemoteTunerCollection
	{
		private readonly IRemoteTuner[] tuners_;

		public TunerCollectionFacade(IRemoteTuner[] tuners)
		{
			tuners_ = tuners;
		}

		[SecurityPermission(SecurityAction.Demand, Flags = SecurityPermissionFlag.Infrastructure)]
		public override object InitializeLifetimeService()
		{
			ILease lease = (ILease)base.InitializeLifetimeService();
			if (lease.CurrentState == LeaseState.Initial)
			{
				lease.InitialLeaseTime = TimeSpan.Zero;
			}
			return lease;
		}

		public int Count
		{
			get
			{
				return tuners_.Length;
			}
		}

		public IRemoteTuner this[int index]
		{
			get
			{
				return tuners_[index];
			}
		}

		public IEnumerator GetEnumerator()
		{
			return new RemoteEnumerator(tuners_.GetEnumerator());
		}
	}
}
