﻿<?xml version="1.0"?>
<!--
   BonSDK Stream service (Local web server contents)
   Copyright (c) http://2sen.dip.jp/dtv/

   This is part of BonSDK.
   BonSDK comes with ABSOLUTELY NO WARRANTY;
   for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/Information">
		<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
				<title>Bon.StreamService (<xsl:value-of select="Node[@name='Environments']/Node[@name='ServerName']" />)</title>
				<link rel="stylesheet" type="text/css" href="Default.css" />
				<link rel="shortcut icon" href="favicon.ico" />
			</head>
			<body>
				<h1>
					<img class="sample" src="images/Bon.StreamServiceIcon.png" alt="Bon.StreamService icon" />Welcome Bon.StreamService (<xsl:value-of select="Node[@name='Environments']/Node[@name='ServerName']" />)
				</h1>
				<h2>
					<img src="images/UtilityLinks.png" alt="Utility links" />Utility links
				</h2>
				<ul>
					<li>
						<a href="StreamServiceHelp.html">
							<img src="images/Help.png" alt="Stream service help" />
							Stream service help
						</a>
					</li>
					<li>
						<a href="RemoteControllerHelp.html">
							<img src="images/Help.png" alt="Remote controller help" />
							Remote controller help
						</a>
					</li>
					<li>
						<a class="externalLink" href="http://2sen.dip.jp/dtv/" target="_blank">Go to original web site</a>
					</li>
					<li>
						<a href="Bon.StreamServiceSetup.msi">
							<img src="images/SetupFile.png" alt="Download setup file (x86)" />Download setup file (x86)
						</a>
					</li>
					<li>
						<a href="Bon.StreamServiceSetup_x64.msi">
							<img src="images/SetupFile.png" alt="Download setup file (x64)" />Download setup file (x64)
						</a>
					</li>
					<li>
						<a href="BonDriver_StreamService.dll">
							<img src="images/BonDriver.png" alt="Download BonDriver_StreamService.dll" />Download BonDriver_StreamService.dll
						</a>
					</li>
					<li>
						<a href="BonDriver_StreamService.ini">
							<img src="images/BonDriver.png" alt="Sample BonDriver_StreamService.ini" />Sample BonDriver_StreamService.ini
						</a>
					</li>
					<li>
						<a>
							<xsl:attribute name="href">
								<xsl:value-of select="Node[@name='Environments']/Node[@name='RemoteControlUrl']" />
							</xsl:attribute>
							<img src="images/RemoteControlAnchor.png" alt="(Remote control anchor)" />
							(Remote control anchor)
						</a>
					</li>
				</ul>
				<h2>
					<img src="images/ServiceStatus.png" alt="Service status" />Service status
				</h2>
				<ul>
					<xsl:for-each select="Node[@name='Environments']/Node">
						<li>
							<xsl:value-of select="@name" />: <xsl:value-of select="." />
						</li>
					</xsl:for-each>
				</ul>
				<h2>
					<img src="images/Tuner.png" alt="Service status" />Tuner status
				</h2>
				<div class="paragraph">
					<xsl:for-each select="Node[@name='Tuners']/Node[@name='Tuner']">
						<h3>
							<a>
								<xsl:attribute name="href">
									<xsl:value-of select="Node[@name='StreamUrl']" />
								</xsl:attribute>
								<xsl:value-of select="Node[@name='TunerName']" />
								<xsl:value-of select="Node[@name='DeviceID']" />
							</a>
						</h3>
						<ul>
							<xsl:for-each select="Node">
								<li>
									<xsl:value-of select="@name" />: <xsl:value-of select="." />
								</li>
							</xsl:for-each>
						</ul>
					</xsl:for-each>
				</div>
				<h2>
					<img src="images/RecorderEntries.png" alt="Recorder status" />Recorder status
				</h2>
				<div class="paragraph">
					Enable recorder: <xsl:value-of select="Node[@name='Recorder']/Node[@name='Enable']" />
					<h3>Storages</h3>
					<ul>
						<xsl:for-each select="Node[@name='Recorder']/Node[@name='Storages']/Node[@name='Storage']">
							<li>
								<xsl:value-of select="Node[@name='StorageID']" /> / <xsl:value-of select="Node[@name='FreeSpace']" /> MB free
							</li>
						</xsl:for-each>
					</ul>
					<h3>Entries</h3>
					<ul>
						<xsl:for-each select="Node[@name='Recorder']/Node[@name='Entries']/Node[@name='Entry']">
							<li>
								"<xsl:value-of select="Node[@name='FileName']" />" [<xsl:value-of select="Node[@name='RecordingStatus']" />]
								<ul>
									<xsl:for-each select="Node">
										<li class="li2">
											<xsl:value-of select="@name" />: <xsl:value-of select="." />
										</li>
									</xsl:for-each>
								</ul>
							</li>
						</xsl:for-each>
					</ul>
				</div>
				<h2>COPYING</h2>
				<div class="paragraph">
					BonSDK Stream service<br />
					Copyright (c) <a class="externalLink" href="http://2sen.dip.jp/dtv/" target="_blank">http://2sen.dip.jp/dtv/</a><br />
					<br />
					This is part of BonSDK.<br />
					BonSDK comes with ABSOLUTELY NO WARRANTY;<br />
					for details see <a href="COPYING.txt">'GNU GENERAL PUBLIC LICENSE 2.0'</a>.
				</div>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
