//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// MediaDecoderIf.h: fBAfR[_C^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// W`[jOXy[XC^tF[X
/////////////////////////////////////////////////////////////////////////////

// `[jOXy[Xƃ`l̖̂ʓIȂ̂ɊYꍇA
// ̃C^tF[XgpĖ̂ɑΉ镶擾鎖B
// 邱ƂŁA̕񂩂P̃`l̓肪eՂɂȂB
// ܂AňŁAWOĂ`[jOXy[XE`l
// ʂ鎖o悤ɂȂB
class IStandardTuningSpace :			public IBonObject
{
public:
	typedef enum
	{
		TUNING_SPACE_VHF = 0x00,
		TUNING_SPACE_UHF = 0x01,
		TUNING_SPACE_CATV = 0x02,
		TUNING_SPACE_BS = 0x03,
		TUNING_SPACE_CS110 = 0x04
	} STANDARD_TUNING_SPACES;
	
	virtual const CBonString GetStandardTuningSpaceName(const STANDARD_TUNING_SPACES tuningSpace) const = 0;
	virtual const CBonString GetStandardChannelName(const STANDARD_TUNING_SPACES tuningSpace, const DWORD dwChannel) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// TS\[X`[ifR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsSourceTuner :			public IBonObject
{
public:
	enum	// OpenTuner() G[R[h
	{
		EC_OPEN_SUCCESS	= 0x00000000UL,		// I[v
		EC_DEVICE_NONE	= 0x00000001UL,		// `[iȂ
		EC_DEVICE_FULL	= 0x00000002UL,		// gp\ȃ`[iȂ
		EC_OPEN_FAILED	= 0x00000003UL,		// I[vs
		EC_INTERNAL_ERR	= 0x00000004UL		// G[
	};

	virtual const DWORD OpenTuner(LPCTSTR lpszBCId) = 0;
	virtual const bool CloseTuner(void) = 0;

	virtual const CBonString GetDeviceName() const = 0;
	virtual const DWORD GetDeviceID(void) const = 0;

	virtual const CBonString GetTuningSpaceName(const DWORD dwSpace) const = 0;
	virtual const CBonString GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const = 0;
	
	virtual const DWORD GetCurSpace(void) const = 0;
	virtual const DWORD GetCurChannel(void) const = 0;

	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel) = 0;
	virtual const bool SetLnbPower(const bool bEnable) = 0;
	virtual const float GetSignalLevel(void) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// TSpPbgfR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsPacketSync :			public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_SYNC_ERR		= 0x00000000UL,		// G[o				(DWORD)G[
		EID_FORMAT_ERR		= 0x00000001UL,		// tH[}bgG[o		(DWORD)G[
		EID_TRANSPORT_ERR	= 0x00000002UL,		// gX|[gG[o		(DWORD)G[
		EID_CONTINUITY_ERR	= 0x00000003UL		// A(hbv)G[o	(DWORD)G[
	};

	virtual void DiscardNullPacket(const bool bEnable = true) = 0;

	virtual void ResetStatistics(void) = 0;

	virtual const DWORD GetPacketStride(void) = 0;

	virtual const DWORD GetInputPacketNum(const WORD wPID = TS_INVALID_PID) = 0;
	virtual const DWORD GetOutputPacketNum(const WORD wPID = TS_INVALID_PID) = 0;

	virtual const DWORD GetInputBitrate(void) = 0;
	virtual const DWORD GetOutputBitrate(void) = 0;

	virtual const DWORD GetSyncErrNum(void) = 0;
	virtual const DWORD GetFormatErrNum(void) = 0;
	virtual const DWORD GetTransportErrNum(void) = 0;
	virtual const DWORD GetContinuityErrNum(const WORD wPID = TS_INVALID_PID) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// TSfXNufR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsDescrambler :			public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_CANT_DESCRAMBLE	= 0x00000000UL,		// RpPbgo			(DWORD)RpPbg
		EID_ECM_PROCESSED	= 0x00000001UL,		// ECM					(DWORD)GetDescramblerState() ^[R[h
		EID_EMM_PROCESSED	= 0x00000002UL		// EMM					(bool)EMM
	};

	enum	// GetDescramblerState() ^[R[h
	{
		DS_NO_ERROR			= 0x00000000UL,		// G[Ȃ
		DS_CAS_ERROR		= 0x00000001UL,		// CASJ[hG[
		DS_NOT_CONTRACTED	= 0x00000002UL		// _
	};

	virtual const bool OpenDescrambler(LPCTSTR lpszBCId) = 0;
	virtual const bool CloseDescrambler(void) = 0;

	virtual void DiscardScramblePacket(const bool bEnable = true) = 0;
	virtual void EnableEmmProcess(const bool bEnable = true) = 0;
	virtual void EnableBuffering(const bool bEnable = true) = 0;

	virtual void ResetStatistics(void) = 0;

	virtual const DWORD GetDescramblingState(const WORD wServiceID) = 0;

	virtual const DWORD GetInputPacketNum(const WORD wPID = TS_INVALID_PID) = 0;
	virtual const DWORD GetOutputPacketNum(const WORD wPID = TS_INVALID_PID) = 0;
	virtual const DWORD GetScramblePacketNum(const WORD wPID = TS_INVALID_PID) = 0;
	virtual const DWORD GetEcmProcessNum(void) = 0;
	virtual const DWORD GetEmmProcessNum(void) = 0;

	virtual const WORD GetCardID(IMediaData *pBuffer) = 0;	// 6oCg
	virtual const WORD GetPowerCtrlInfo(IHalCasCard::POWERCTRLINFO *pPowerCtrlInfo) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// vOAiCUfR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IProgAnalyzer :			public IBonObject
{
public:
	virtual const WORD GetNetworkID(void) const = 0;
	virtual const WORD GetTsID(void) const = 0;
	virtual const WORD GetServiceIDFromPID(const WORD wPID) const = 0;
	virtual const WORD GetPmtPIDFromServiceID(const WORD wServiceID) const = 0;

	virtual const DWORD GetServiceNum(void) const = 0;
	virtual const WORD GetServiceID(const DWORD dwIndex = 0UL) const = 0;
	virtual const WORD GetProgramVideoPID(const WORD wServiceID = 0x0000U) const = 0;
	virtual const WORD GetProgramAudioPID(const WORD wServiceID = 0x0000U) const = 0;
	virtual const WORD GetProgramPcrPID(const WORD wServiceID = 0x0000U) const = 0;

	virtual const CBonString GetNetworkName() const = 0;
	virtual const CBonString GetServiceName(const WORD wServiceID = 0x0000U) const = 0;
	virtual const bool GetStreamTime(SYSTEMTIME *pStreamTime) const = 0;

	virtual const WORD GetCurrentServiceID(void) const = 0;
	virtual const bool SetCurrentServiceID(const WORD wServiceID = 0x0000U) = 0;

	virtual const IEpgItem * GetCurrentEpgInfo(const WORD wServiceID = 0x0000U) const = 0;
	virtual const IEpgItem * GetNextEpgInfo(const WORD wServiceID = 0x0000U) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// t@CC^fR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IFileWriter :				public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_BUFF_OVERFLOW	= 0x00000000UL		// obt@I[ot[			N/A
	};
	
	virtual const bool OpenFile(LPCTSTR lpszFileName, const bool bAsyncWrite = false, const DWORD dwBuffSize = 0UL) = 0;
	virtual bool CloseFile(void) = 0;
	
	virtual const ULONGLONG GetFileLength(void) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// t@C[_fR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IFileReader :				public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_READ_START	= 0x00000000UL,			// [hJn					N/A
		EID_READ_END	= 0x00000001UL,			// [hI					N/A
		EID_PRE_READ	= 0x00000002UL,			// [hO						N/A
		EID_POST_READ	= 0x00000003UL			// [h						N/A
	};
	
	virtual const bool OpenFile(LPCTSTR lpszFileName, const bool bAsyncRead = false, const DWORD dwBuffSize = 0UL) = 0;
	virtual bool CloseFile(void) = 0;

	virtual const DWORD ReadSync(const DWORD dwReadSize) = 0;
	
	virtual const bool SetReadPos(const ULONGLONG llPos) = 0;
	virtual const ULONGLONG GetReadPos(void) = 0;
	
	virtual const ULONGLONG GetFileLength(void) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// fBAOofR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IMediaGrabber :			public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_ON_PLAY			= 0x00000000UL,		// PlayDecoder()				N/A
		EID_ON_STOP			= 0x00000001UL,		// StopDecoder()				N/A
		EID_ON_RESET		= 0x00000002UL,		// ResetDecoder()				N/A
		EID_ON_MEDIADATA	= 0x00000003UL		// InputMedia()					(IMediaData *)̓f[^
	};
};

}
