//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// TsEpgIf.h: TS EPG C^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "TsDataEncode.h"


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// EITACeC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IEitItem :	public IBonObject
{
public:
	virtual const bool ParseItem(void) = 0;

	virtual const WORD GetProgramID(void) const = 0;
	virtual const CTsTime & GetStartTime(void) const = 0;
	virtual const DWORD GetDuration(void) const = 0;
	virtual const BYTE GetRunningStatus(void) const = 0;
	virtual const bool IsScrambled(void) const = 0;
	virtual const IDescBlock * GetEventDesc(void) const = 0;
	
	virtual const bool CopyItem(const IEitItem *pSrc) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// EPGACeC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IEpgItem :	public IBonObject
{
public:
	enum	// StoreEitItem()AGetStoreState() ^[R[h(OR)
	{
		SST_EMPTY			= 0x00U,	// f[^Ȃ
		SST_EVENT_ID		= 0x01U,	// EVENT IDXgAς
		SST_SHORT_INFO		= 0x02U,	// Z`CxgXgAς
		SST_EXTEND_INFO		= 0x04U,	// g`CxgXgAς
		SST_VIDEO_INFO		= 0x08U,	// fXgAς
		SST_AUDIO_INFO		= 0x10U,	// XgAς
		SST_CONTENT_INFO	= 0x20U,	// RegXgAς
		SST_SCHEDULE_CHANGE	= 0x40U,	// XPW[ωo
		SST_COMPLETE		= (SST_EVENT_ID | SST_SHORT_INFO | SST_EXTEND_INFO | SST_VIDEO_INFO | SST_AUDIO_INFO)
	};

	enum	// GetAudioMode() ^[R[h
	{
		ADM_UNDEFINED		= 0x00U,	// `
		ADM_MONO			= 0x01U,	// m
		ADM_DUAL			= 0x02U,	// d
		ADM_STEREO			= 0x03U,	// XeI
		ADM_SURROUND		= 0x04U		// TEh
	};

	virtual const BYTE StoreEitItem(const IEitItem *pEitItem) = 0;
	virtual void Reset(void) = 0;

	virtual const BYTE GetStoreState(void) const = 0;

// SST_EVENT_IDXgAς݂ŗL
	virtual const WORD GetProgramID(void) const = 0;
	virtual const CTsTime & GetStartTime(void) const = 0;
	virtual const DWORD GetDuration(void) const = 0;
	virtual const bool IsScrambled(void) const = 0;

// SST_SHORT_INFOXgAς݂ŗL
	virtual const CBonString GetEventTitle() const = 0;
	virtual const CBonString GetEventInfo() const = 0;

// SST_EXTEND_INFOXgAς݂ŗL
	virtual const CBonString GetEventDetail() const = 0;

// SST_VIDEO_INFOXgAς݂ŗL
	virtual const WORD GetVideoResolution(void) const = 0;
	virtual const bool IsVideoProgressive(void) const = 0;
	virtual const bool IsVideoAspectWide(void) const = 0;
	virtual const bool IsVideoPanAndScan(void) const = 0;

// SST_AUDIO_INFOXgAς݂ŗL
	virtual const BYTE GetAudioMode(void) const = 0;

// SST_CONTENT_INFOXgAς݂ŗL
	virtual const DWORD GetGenreNum(void) const = 0;
	virtual const BYTE GetGenreLevel1(const DWORD dwIndex = 0UL) const = 0;
	virtual const BYTE GetGenreLevel2(const DWORD dwIndex = 0UL) const = 0;

	virtual const bool CopyItem(const IEpgItem *pSrc) = 0;
};

}
