//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonDebug.cpp: fobO⏕Cu
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"

#include <atlbase.h>

#include <tchar.h>
#include <stdlib.h>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// ėpONX
/////////////////////////////////////////////////////////////////////////////

static const CBonString g_EmptyDescription(TEXT("OɊւ͂܂"));

CBonException::CBonException(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId, LPCTSTR pDescription)
	: m_ClassId(ClassId)
	, m_SourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_Description((pDescription != 0) ? CBonString(pDescription) : g_EmptyDescription)
{
}

CBonException::CBonException(LPCWSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId, LPCTSTR pDescription)
	: m_ClassId(ClassId)
	, m_SourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_Description((pDescription != 0) ? CBonString(pDescription) : g_EmptyDescription)
{
}

CBonException::CBonException(const CBonException &rhs)
	: m_ClassId(rhs.m_ClassId)
	, m_SourceFile(rhs.m_SourceFile)
	, m_dwSourceLine(rhs.m_dwSourceLine)
	, m_Description(rhs.m_Description)
{
}

CBonException::~CBonException(void)
{
	// Ȃ
}

CBonException &CBonException::operator =(const CBonException &rhs)
{
	m_ClassId = rhs.m_ClassId;
	m_SourceFile = rhs.m_SourceFile;
	m_dwSourceLine = rhs.m_dwSourceLine;
	m_Description = rhs.m_Description;

	return *this;
}

CBonException &CBonException::operator ()(LPCTSTR lpszFormat, ...)
{
	if (lpszFormat != 0)
	{
		// 
		va_list va;
		va_start(va ,lpszFormat);
		m_Description = CBonString::FormatV(lpszFormat, va);
		va_end(va);
	}
	
	return *this;
}

const BONGUID CBonException::GetGuid(void) const
{
	// OBONGUIDԂ
	return m_ClassId;
}

const CBonString CBonException::GetDescription() const
{
	return m_Description;
}

const CBonString CBonException::GetSourceFile() const
{
	// Õ\[Xt@CԂ
	TCHAR szPathName[_MAX_PATH] = TEXT("");
	TCHAR szFileName[_MAX_FNAME] = TEXT("");
	TCHAR szExtName[_MAX_EXT] = TEXT("");

	// t@C𒊏o
	::_tsplitpath(m_SourceFile, NULL, NULL, szFileName, szExtName);
	::_tmakepath(szPathName, NULL, NULL, szFileName, szExtName);	

	return szPathName;
}

const DWORD CBonException::GetSourceLine(void) const
{
	// Õ\[XR[hsԂ
	return m_dwSourceLine;
}


/////////////////////////////////////////////////////////////////////////////
// ėpƍNX
/////////////////////////////////////////////////////////////////////////////

CBonAssert::CBonAssert(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId)
	: m_SourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_ClassId(ClassId)
{
	// Ȃ
}

void CBonAssert::InternalAssert(const CBonString &message)
{
	CBonString temp;
	if (m_ClassId != BCID_NULL)
	{
		CBonString moduleName = TEXT("s");
		CBonString className = TEXT("s");

		// W[擾
		::GET_BON_MODULE_NAME(::GET_BON_CLASS_MODULE(m_ClassId), &moduleName);
		
		// NX擾
		::GET_BON_CLASS_NAME(m_ClassId, &className);
		
		// fobOo͕񐶐
		temp = CBonString::Format(TEXT("[OCxg]\r\n@Eꏊ\tF %1!s!W[@%2!s!NX\r\n@E\[X\tF %3!s!@%4!lu! s\r\n@E\tF %5!s!\r\n"),
			moduleName.GetString(), className.GetString(), m_SourceFile.GetString(), m_dwSourceLine, message.GetString());
	}
	else
	{
		// fobOo͕񐶐
		temp = CBonString::Format(TEXT("[OCxg]\r\n@Eꏊ\tF O[o͔BonNX\r\n@E\[X\tF %1!s!@%2!lu! s\r\n@E\tF %3!s!\r\n"),
			m_SourceFile.GetString(), m_dwSourceLine, message.GetString());
	}
	
	BON_TRACE(TraceType_Error, temp);

#ifdef _DEBUG
	while (true)
	{
		DWORD result = ::MessageBox(NULL, temp + TEXT("OX[܂H (LZŃfobO)"), TEXT("BonSDK Oʒm"), MB_YESNOCANCEL | MB_ICONERROR | MB_TASKMODAL);
		if (result == IDYES)
		{
			throw CBonException(m_SourceFile, m_dwSourceLine, m_ClassId, message);
		}
		else if (result == IDNO)
		{
			return;
		}
		::DebugBreak();
	}
#endif
}

void CBonAssert::operator()(const bool bSuccess, LPCTSTR lpszFormat, ...)
{
	// 
	if (bSuccess == true)
	{
		return;
	}

	// tH[}bg
	if (lpszFormat != 0)
	{
		va_list va;
		va_start(va, lpszFormat);
		InternalAssert(CBonString::FormatV(lpszFormat, va));
		va_end(va);
	}
	else
	{
		InternalAssert(TEXT("(Ȃ)"));
	}
}

void CBonAssert::operator()(const void *pPointer, LPCTSTR lpszFormat, ...)
{
	// 
	if (pPointer != 0)
	{
		return;
	}

	// tH[}bg
	if (lpszFormat != 0)
	{
		va_list va;
		va_start(va, lpszFormat);
		InternalAssert(CBonString::FormatV(lpszFormat, va));
		va_end(va);
	}
	else
	{
		InternalAssert(TEXT("(Ȃ)"));
	}
}


/////////////////////////////////////////////////////////////////////////////
// fobO⏕֐
/////////////////////////////////////////////////////////////////////////////

const BONGUID GetGuid(void)
{
	// O[oXR[v̏ꍇBCID_NULLԂ
	return BCID_NULL;
}

}


/////////////////////////////////////////////////////////////////////////////
// g[Xo
/////////////////////////////////////////////////////////////////////////////

class CBonTrace
{
private:
	DWORD mask_;
	PTRACE_CALLBACK pCallback_;

	// OutputDebugString() API gpftHg̃nh
	static void DefaultCallback(BonTraceType type, LPCTSTR lpszMessage)
	{
		switch (type)
		{
		case TraceType_Debug:
			::OutputDebugString(CBonString::Format(TEXT("BON_TRACE: Debug: %1!s!"), lpszMessage));
			break;
		case TraceType_Information:
			::OutputDebugString(CBonString::Format(TEXT("BON_TRACE: Information: %1!s!"), lpszMessage));
			break;
		case TraceType_Warning:
			::OutputDebugString(CBonString::Format(TEXT("BON_TRACE: Warning: %1!s!"), lpszMessage));
			break;
		case TraceType_Error:
			::OutputDebugString(CBonString::Format(TEXT("BON_TRACE: Error: %1!s!"), lpszMessage));
			break;
		default:
			::OutputDebugString(CBonString::Format(TEXT("BON_TRACE: (Unknown type): %1!s!"), lpszMessage));
			break;
		}
	}

	CBonTrace(const CBonTrace &);
	void operator =(const CBonTrace &);

public:
	CBonTrace()
		: pCallback_(DefaultCallback)
	{
#ifdef _DEBUG
		mask_ = 0xffffffffUL;
#else
		mask_ = 0xfffffffeUL;
#endif
		ATL::CRegKey key;
		if (key.Open(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\BonSDK"), KEY_READ) == ERROR_SUCCESS)
		{
			key.QueryDWORDValue(TEXT("BonTraceMask"), mask_);
		}
	}

	void RegisterCallback(PTRACE_CALLBACK pCallback)
	{
		if (pCallback != 0)
		{
			pCallback_ = pCallback;
		}
		else
		{
			pCallback_ = DefaultCallback;
		}
	}

	const bool IsTraceTarget(BonTraceType type) const
	{
		return (type & mask_) != 0;
	}

	void Output(BonTraceType type, const Bon::CBonString &message) const
	{
		if (IsTraceTarget(type) == true)
		{
			pCallback_(type, message);
		}
	}
};

static CBonTrace g_BonTrace;

extern "C" void BON_TRACE_REGISTER_CALLBACK(PTRACE_CALLBACK pCallback)
{
	g_BonTrace.RegisterCallback(pCallback);
}

extern "C" void BON_TRACE(BonTraceType type, LPCTSTR lpszFormat, ...)
{
	va_list va;
	va_start(va, lpszFormat);
	g_BonTrace.Output(type, CBonString::FormatV(lpszFormat, va));
	va_end(va);
}

void BON_TRACE(BonTraceType type, const Bon::CBonString &message)
{
	g_BonTrace.Output(type, message);
}

extern "C" bool IS_BON_TRACE_TARGET(BonTraceType type)
{
	return g_BonTrace.IsTraceTarget(type);
}
