//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// ModCatalogBase.cpp: W[J^ONX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "ModCatalogBase.h"
#include <StdLib.h>
#include <TChar.h>


#pragma comment(lib, "Version.lib")


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// W[J^ONX
/////////////////////////////////////////////////////////////////////////////

const WORD CModCatalogBase::GetVersion(void) const
{
	if(!m_hModule){
		// o[W\[X擾Ȃꍇ
		return m_wVersion;
		}

	WORD wVersion = 0x0000U;

	try{
		// W[̃t@C擾
		TCHAR szFileName[_MAX_PATH + 1];
		if(!::GetModuleFileName(m_hModule, szFileName, sizeof(szFileName) - 1))throw BON_EXPECTION();

		// o[W񃊃\[X̃TCY擾
		DWORD dwHandle = 0;
		DWORD dwLength = ::GetFileVersionInfoSize(szFileName, &dwHandle);
		if(!dwLength)throw BON_EXPECTION();

		// o[W񃊃\[X[h
		CMediaData Buffer((const BYTE)0x00U, dwLength + 1UL);
		if(!::GetFileVersionInfo(szFileName, 0, dwLength, Buffer.GetData()))throw BON_EXPECTION();

		// LangCodepage擾
		DWORD *pdwLang;
		TCHAR szSubBlock[50] = TEXT("\\VarFileInfo\\Translation");
		if(!::VerQueryValue(Buffer.GetData(), szSubBlock, (void **)&pdwLang, (PUINT)&dwLength))throw BON_EXPECTION();

		// 擾
		LPTSTR lpszBuffer;
		::_stprintf(szSubBlock, TEXT("\\StringFileInfo\\%04x%04x\\ProductVersion"), LOWORD(*pdwLang), HIWORD(*pdwLang));
		if(!::VerQueryValue(Buffer.GetData(), szSubBlock, (void **)&lpszBuffer, (PUINT)&dwLength))throw BON_EXPECTION();
		
		// `
		DWORD adwVers[4] = {0UL, 0UL, 0UL, 0UL};
		::_stscanf(lpszBuffer, TEXT("%lu,%lu,%lu,%lu"), &adwVers[0], &adwVers[1], &adwVers[2], &adwVers[3]);
		
		wVersion = (WORD)(((adwVers[0] & 0xFUL) << 12) | ((adwVers[1] & 0xFUL) << 8) | ((adwVers[2] & 0xFUL) << 4) | ((adwVers[3] & 0xFUL) << 0));
		}
	catch(const CBonException &){
		// G[
		BON_ASSERT();
		return 0x0000U;
		}

	return wVersion;
}

const CBonString CModCatalogBase::GetComment() const
{
	// RgԂ
	return m_Comment;
}

const CBonString CModCatalogBase::GetAuthor() const
{
	// ҖԂ
	return m_Author;
}

const CBonString CModCatalogBase::GetWebsite() const
{
	// AԂ
	return m_Website;
}

const BONGUID CModCatalogBase::EnumClass(LPCTSTR lpszBIId, const DWORD dwIndex) const
{
	if(!m_pClassInfo)return BCID_NULL;

	// w肳ꂽC^tF[XɑΉNX񋓂
	for(DWORD dwInfoPos = 0UL, dwClassPos = 0UL ; dwInfoPos < m_dwClassNum ; dwInfoPos++){
		if(m_pClassInfo[dwInfoPos].szBIId == lpszBIId){
			if(dwClassPos++ == dwIndex){
				return ::BON_NAME_TO_GUID(m_pClassInfo[dwInfoPos].szBCId);
				}
			}	
		}

	return BCID_NULL;
}

const CBonString CModCatalogBase::GetClassDesc(const BONGUID ClassId) const
{
	if(!m_pClassInfo)return CBonString::GetEmpty();

	// w肳ꂽGUID̃NX
	for(DWORD dwInfoPos = 0UL ; dwInfoPos < m_dwClassNum ; dwInfoPos++){
		if(::BON_NAME_TO_GUID(m_pClassInfo[dwInfoPos].szBCId) == ClassId){
			// GUIDvAԂ
			return m_pClassInfo[dwInfoPos].szDesc;
			}
		}

	return CBonString::GetEmpty();
}

CModCatalogBase::CModCatalogBase(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_pClassInfo(NULL)
	, m_dwClassNum(0UL)
	, m_hModule(NULL)
	, m_wVersion(0U)
{
	// gpĂ͂ȂȂ
	BON_ASSERT(false);
}

CModCatalogBase::CModCatalogBase(IBonObject *pOwner, const MOD_CLASS_INFO *pClassInfo, const DWORD dwClassNum, const HMODULE hModule, const LPCTSTR lpszComment, const LPCTSTR lpszAuthor, const LPCTSTR lpszWebsite)
	: CBonObject(pOwner)
	, m_pClassInfo(pClassInfo)
	, m_dwClassNum(dwClassNum)
	, m_hModule(hModule)
	, m_wVersion(0U)
	, m_Comment(lpszComment)
	, m_Author(lpszAuthor)
	, m_Website(lpszWebsite)
{
	// Ȃ
}

CModCatalogBase::CModCatalogBase(IBonObject *pOwner, const MOD_CLASS_INFO *pClassInfo, const DWORD dwClassNum, const WORD wVersion, const LPCTSTR lpszComment, const LPCTSTR lpszAuthor, const LPCTSTR lpszWebsite)
	: CBonObject(pOwner)
	, m_pClassInfo(pClassInfo)
	, m_dwClassNum(dwClassNum)
	, m_hModule(NULL)
	, m_wVersion(wVersion)
	, m_Comment(lpszComment)
	, m_Author(lpszAuthor)
	, m_Website(lpszWebsite)
{
	// Ȃ
}

CModCatalogBase::~CModCatalogBase(void)
{
	// Ȃ
}

}
