//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// RegCfgStorage.cpp: ėpRtBM[VXg[WNX(WXg)
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TChar.h"
#include "RegCfgStorage.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// ftHg̃ZNV
#define DEF_PATHNAME		TEXT("Bon")		// /HKEY_CURRENT_USER/Software/Bon/

#define MAX_KEYNAME_LEN		256UL			// őL[
#define MAX_VALNAME_LEN		256UL			// őACe


/////////////////////////////////////////////////////////////////////////////
// ėpRtBM[VXg[WNX(WXg)
/////////////////////////////////////////////////////////////////////////////

const bool CRegCfgStorage::OpenStorage(LPCTSTR lpszPathName, const bool bCreate)
{
	// UN[Y
	CloseStorage();

	// pX𐶐
	TCHAR szKeyPath[MAX_KEYNAME_LEN] = {TEXT('\0')};
	::_stprintf(szKeyPath, TEXT("Software\\%s"), (lpszPathName)? lpszPathName : DEF_PATHNAME);
	
	// WXgI[v
	if(bCreate){
		// L[݂Ȃꍇ̓L[쐬
		if(::RegCreateKeyEx(HKEY_CURRENT_USER, szKeyPath, 0UL, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &m_hRegKey, NULL) != ERROR_SUCCESS)return false;
		}
	else{
		// L[݂Ȃꍇ͎s
		if(::RegOpenKeyEx(HKEY_CURRENT_USER, szKeyPath, 0UL, KEY_ALL_ACCESS, &m_hRegKey) != ERROR_SUCCESS)return false;
		}

	return true;
}

const bool CRegCfgStorage::CloseStorage(void)
{
	if(!m_hRegKey)return false;

	// WXg
	::RegCloseKey(m_hRegKey);
	m_hRegKey = NULL;

	return true;
}

IConfigStorage * CRegCfgStorage::OpenSection(LPCTSTR lpszSection, const bool bCreate)
{
	if(!m_hRegKey || !lpszSection)return NULL;

	// TuL[I[v
	HKEY hSubKey = NULL;

	if(bCreate){
		// TuL[݂Ȃꍇ̓TuL[쐬
		if(::RegCreateKeyEx(m_hRegKey, lpszSection, 0UL, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hSubKey, NULL) != ERROR_SUCCESS)return NULL;
		}
	else{
		// TuL[݂Ȃꍇ͎s
		if(::RegOpenKeyEx(m_hRegKey, lpszSection, 0UL, KEY_ALL_ACCESS, &hSubKey) != ERROR_SUCCESS)return NULL;
		}

	// VCX^X
	CRegCfgStorage *pNewInstance = new CRegCfgStorage(NULL);
	
	if(!pNewInstance){
		::RegCloseKey(hSubKey);
		return NULL;
		}

	// VCX^XɃnhݒ
	pNewInstance->m_hRegKey = hSubKey;
	
	return pNewInstance;
}

const DWORD CRegCfgStorage::GetSectionNum(void)
{
	if(!m_hRegKey)return 0UL;

	DWORD dwSubKeyNum = 0UL;

	// TuL[擾
	if(::RegQueryInfoKey(m_hRegKey, NULL, NULL, NULL, &dwSubKeyNum, NULL, NULL, NULL, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)return 0UL;

	// TuL[Ԃ
	return dwSubKeyNum;
}

const CBonString CRegCfgStorage::EnumSection(const DWORD dwIndex)
{
	if(!m_hRegKey)return CBonString::GetEmpty();

	TCHAR szSection[MAX_KEYNAME_LEN + 1];
	::memset(szSection, 0, sizeof szSection);
	DWORD dwSectionLen = MAX_KEYNAME_LEN;

	// TuL[񋓂
	if(::RegEnumKeyEx(m_hRegKey, dwIndex, szSection, &dwSectionLen, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)return CBonString::GetEmpty();

	return CBonString(szSection);
}

const bool CRegCfgStorage::DeleteSection(LPCTSTR lpszSection)
{
	if(!m_hRegKey)return 0UL;

	// TuL[폜
	return (::RegDeleteKey(m_hRegKey, lpszSection) == ERROR_SUCCESS)? true : false;
}

const DWORD CRegCfgStorage::GetItemNum(void)
{
	if(!m_hRegKey)return 0UL;

	DWORD dwItemNum = 0UL;

	// ACe擾
	if(::RegQueryInfoKey(m_hRegKey, NULL, NULL, NULL, NULL, NULL, NULL, &dwItemNum, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)return 0UL;

	// ACeԂ
	return dwItemNum;
}

const CBonString CRegCfgStorage::EnumItem(const DWORD dwIndex)
{
	if(!m_hRegKey)return CBonString::GetEmpty();

	TCHAR szBuffer[MAX_VALNAME_LEN + 1];
	::memset(szBuffer, 0, sizeof szBuffer);
	DWORD dwValueLen = MAX_VALNAME_LEN;

	// Gg񋓂
	if(::RegEnumValue(m_hRegKey, dwIndex, szBuffer, &dwValueLen, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)return CBonString::GetEmpty();

	return CBonString(szBuffer);
}

const DWORD CRegCfgStorage::GetItemType(LPCTSTR lpszItem)
{
	if(!m_hRegKey)return 0UL;

	DWORD dwType = REG_NONE;
	
	// Gǧ^擾
	if(::RegQueryValueEx(m_hRegKey, lpszItem, NULL, &dwType, NULL, NULL) != ERROR_SUCCESS)return 0UL;

	// BOOLDWORD͋ʂłȂ([ÜɈς˂)
	switch(dwType){
		case REG_DWORD	: return ITEM_TYPE_INT;
		case REG_SZ		: return ITEM_TYPE_TEXT;		
		default			: return ITEM_TYPE_INVALID;
		}
}

const bool CRegCfgStorage::DeleteItem(LPCTSTR lpszItem)
{
	if(!m_hRegKey)return 0UL;
	
	// Gg폜
	return (::RegDeleteValue(m_hRegKey, lpszItem))? true : false;
}

const bool CRegCfgStorage::SetBoolItem(LPCTSTR lpszItem, const bool bValue)
{
	if(!m_hRegKey)return 0UL;
	
	const DWORD dwValue = (bValue)? 1UL : 0UL;
	
	// BOOLZ[u
	return (::RegSetValueEx(m_hRegKey, lpszItem, 0UL, REG_DWORD, (const BYTE *)&dwValue, sizeof(dwValue)))? true : false;
}

const bool CRegCfgStorage::SetIntItem(LPCTSTR lpszItem, const DWORD dwValue)
{
	if(!m_hRegKey)return 0UL;

	// DWORDZ[u
	return (::RegSetValueEx(m_hRegKey, lpszItem, 0UL, REG_DWORD, (const BYTE *)&dwValue, sizeof(dwValue)))? true : false;
}

const bool CRegCfgStorage::SetTextItem(LPCTSTR lpszItem, LPCTSTR lpszValue)
{
	if(!m_hRegKey)return 0UL;

	// Z[u
	return (::RegSetValueEx(m_hRegKey, lpszItem, 0UL, REG_SZ, (const BYTE *)lpszValue, (::_tcslen(lpszValue) + 1UL) * sizeof(lpszValue[0])))? true : false;
}

const bool CRegCfgStorage::GetBoolItem(LPCTSTR lpszItem, const bool bDefault)
{
	if(!m_hRegKey)return bDefault;

	DWORD dwType = REG_NONE;
	DWORD dwValue = 0UL;

	// BOOL[h
	if(::RegQueryValueEx(m_hRegKey, lpszItem, NULL, &dwType, (BYTE *)&dwValue, NULL) != ERROR_SUCCESS)return bDefault;

	// ^`FbN
	if(dwType != REG_DWORD)return bDefault;

	// lԂ
	return (dwValue)? true : false;
}

const DWORD CRegCfgStorage::GetIntItem(LPCTSTR lpszItem, const DWORD dwDefault, const DWORD dwMax, const DWORD dwMin)
{
	if(!m_hRegKey)return dwDefault;

	DWORD dwType = REG_NONE;
	DWORD dwValue = 0UL;

	// DWORD[h
	if(::RegQueryValueEx(m_hRegKey, lpszItem, NULL, &dwType, (BYTE *)&dwValue, NULL) != ERROR_SUCCESS)return dwDefault;

	// ^`FbN
	if(dwType != REG_DWORD)return dwDefault;

	// lԂ
	return ((dwValue >= dwMin) && (dwValue <= dwMax))? dwValue : dwDefault;
}

const CBonString CRegCfgStorage::GetTextItem(LPCTSTR lpszItem, LPCTSTR lpszDefault)
{
	if(!m_hRegKey){
		if(lpszDefault){
			return CBonString(lpszDefault);
			}
		return CBonString::GetEmpty();
		}

	DWORD dwType = REG_SZ;
	DWORD dwSize = 0xFFFFFFFFUL;
	
	// TCY擾
	const LONG lReturn = ::RegQueryValueEx(m_hRegKey, lpszItem, NULL, &dwType, NULL, &dwSize);
	
	if((lReturn != ERROR_SUCCESS) || (dwType != REG_SZ)){
		if(lpszDefault){
			return CBonString(lpszDefault);
			}

		return CBonString::GetEmpty();
		}

	// 擾
	TCHAR *pszBuffer = new TCHAR[dwSize / sizeof(TCHAR) + 1];
	if(::RegQueryValueEx(m_hRegKey, lpszItem, NULL, &dwType, (BYTE *)pszBuffer, &dwSize) != ERROR_SUCCESS){
		delete [] pszBuffer;
		if(lpszDefault){
			return CBonString(lpszDefault);
			}

		return CBonString::GetEmpty();
		}
	
	// i[Ԃ
	CBonString temp(pszBuffer);
	delete [] pszBuffer;

	return temp;
}

CRegCfgStorage::CRegCfgStorage(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_hRegKey(NULL)
{

}

CRegCfgStorage::~CRegCfgStorage(void)
{
	// Xg[WN[Y
	CloseStorage();
}
