//////////////////////////////////////////////////////////////////////////
// BonSDK Friio (White/Black) tuner driver library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonBlackTuner.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonBlackTuner.h"

#include <atlbase.h>

#include <math.h>
#include <tchar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT(" Friio USB 2.0 Digital TV Receiver")

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg

// LNBLWXg
#define ENABLE_LNB_REGKEY	TEXT("Software\\BonSDK\\FriioDriver")
#define ENABLE_LNB_REGNAME	TEXT("EnableLnbFunction")
#define ENABLE_LNB_REGVALUE	1


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const CBonString CBonBlackTuner::GetDeviceName() const
{
	static const CBonString deviceName(DEVICENAME);

	// foCXԂ
	return deviceName;
}

const DWORD CBonBlackTuner::GetTotalDeviceNum(void) const
{
	// FriiȏԂ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetTotalNum() : 0UL;
}

const DWORD CBonBlackTuner::GetActiveDeviceNum(void) const
{
	// gpFriio̐Ԃ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetActiveNum() : 0UL;
}

const bool CBonBlackTuner::OnOpenTuner(void)
{
	try
	{
		// hCo
		if(!m_BonEnumerator.EnumDevice(true))throw __LINE__;
	}
	catch (...)
	{
		// G[
		return false;
	}

	return true;
}

const CBonString CBonBlackTuner::EnumTuningSpace(const DWORD dwSpace) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_BS);
	case 1:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_CS110);
	}
	return CBonString::GetEmpty();
}

const CBonString CBonBlackTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_BS, dwChannel);
	case 1:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_CS110, dwChannel);
	}
	return CBonString::GetEmpty();
}

const bool CBonBlackTuner::OnSetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jOV[PXϕ
	static const BYTE abyPllConfA[] = {0x08U, 0x08U, 0x08U, 0x08U, 0x09U, 0x09U, 0x09U, 0x0AU, 0x0AU, 0x0AU, 0x0AU, 0x0CU, 0x0CU, 0x0DU, 0x0DU, 0x0DU, 0x0EU, 0x0EU, 0x0EU, 0x0FU, 0x0FU, 0x0FU, 0x10U};	// 1/17 +40
	static const BYTE abyPllConfB[] = {0x32U, 0x32U, 0x80U, 0x80U, 0x64U, 0x64U, 0x64U, 0x00U, 0x00U, 0x4CU, 0x4CU, 0x9AU, 0xEAU, 0x3AU, 0x8AU, 0xDAU, 0x2AU, 0x7AU, 0xCAU, 0x1AU, 0x6AU, 0xBAU, 0x0AU};	// 2/18 +40
	static const BYTE abyPllConfC[] = {0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 75	+02
	static const BYTE abyPllConfD[] = {0x10U, 0x11U, 0x30U, 0x31U, 0x90U, 0x91U, 0x92U, 0xD0U, 0xD1U, 0xF1U, 0xF2U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 76	+02

	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(GetModuleInstance(), MAKEINTRESOURCE(IDR_CHSEQ_BLACK), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(GetModuleInstance(), hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(GetModuleInstance(), hRsrc);

	// \[Xf[^𑗐M
	const DWORD dwChIndex = dwSpace * 11UL + dwChannel;
	DWORD dwXmitNum = 0UL;
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while(dwXmited < dwIoReqSize)
	{
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// Mobt@NA
		BYTE RxdBuff[256];
		::ZeroMemory(RxdBuff, sizeof RxdBuff);

		// Mf[^
		BYTE TxdBuff[256];
		::ZeroMemory(TxdBuff, sizeof TxdBuff);
		::CopyMemory(TxdBuff, pFixedBuff, pFixedReqHead->wTxdSize);

		switch(dwXmitNum++){
			case 0UL  :	TxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 1UL  :	TxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 16UL :	TxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 17UL :	TxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 74UL :	TxdBuff[ 2] = abyPllConfC[dwChIndex];	break;
			case 75UL :	TxdBuff[ 2] = abyPllConfD[dwChIndex];	break;
		}

		// f[^M
		if(SendIoRequest(pFixedReqHead->dwIoCode, TxdBuff, pFixedReqHead->wTxdSize, RxdBuff, pFixedReqHead->wRxdSize) == -1)return false;
		pFixedBuff += pFixedReqHead->wTxdSize;

		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
	}

	return true;
}

const bool CBonBlackTuner::SetLnbPower(const bool bEnable)
{
	static const BYTE SetLnbReq[][0x26] =
	{
		{ 0x40, 0x01 ,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
		{ 0x40, 0x01 ,0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	};

	// #### ߓdی@\̂ȂFriioł͏đ̉\邽߁AWXgɃtOĂꍇ ###
	ATL::CRegKey key;
	if (key.Open(HKEY_LOCAL_MACHINE, ENABLE_LNB_REGKEY, KEY_READ) != ERROR_SUCCESS)
	{
		return false;
	}
	DWORD value = 0;
	if (key.QueryDWORDValue(ENABLE_LNB_REGNAME, value) != ERROR_SUCCESS)
	{
		return false;
	}
	if (value != ENABLE_LNB_REGVALUE)
	{
		return false;
	}

	// Mobt@NA
	BYTE RxdBuff[256];
	::ZeroMemory(RxdBuff, sizeof RxdBuff);

	// Mxݒ
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)SetLnbReq[bEnable ? 1 : 0], sizeof(SetLnbReq),
		RxdBuff, sizeof(SetLnbReq)) == -1)return false;

	return true;
}

const float CBonBlackTuner::GetSignalLevel(void) const
{
	// Mxv
	static const BYTE abyGetLevReq[] = {0xC0, 0x02 ,0x00, 0x32, 0xBA, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// `⊮ŋߎ
	static const float afLevelTable[] =
	{
		24.07f,	// 00	00	0		24.07dB
		24.07f,	// 10	00	4096	24.07dB
		18.61f,	// 20	00	8192	18.61dB
		15.21f,	// 30	00	12288	15.21dB
		12.50f,	// 40	00	16384	12.50dB
		10.19f,	// 50	00	20480	10.19dB
		8.140f,	// 60	00	24576	8.140dB
		6.270f,	// 70	00	28672	6.270dB
		4.550f,	// 80	00	32768	4.550dB
		3.730f,	// 88	00	34816	3.730dB
		3.630f,	// 88	FF	35071	3.630dB
		2.940f,	// 90	00	36864	2.940dB
		1.420f,	// A0	00	40960	1.420dB
		0.000f	// B0	00	45056	-0.01dB
	};

	// Mobt@NA
	BYTE RxdBuff[256];
	::ZeroMemory(RxdBuff, sizeof RxdBuff);

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)abyGetLevReq, sizeof(abyGetLevReq), RxdBuff, sizeof(abyGetLevReq)) == -1)return 0.0f;

	// MxvZ
	if(RxdBuff[40] <= 0x10U){
		// őNbv
		return 24.07f;
	}
	else if(RxdBuff[40] >= 0xB0U){
		// ŏNbv
		return 0.0f;
	}
	else{
		// `⊮
		const float fMixRate = (float)(((WORD)(RxdBuff[40] & 0x0FU) << 8) | (WORD)RxdBuff[41]) / 4095.0f;
		return afLevelTable[RxdBuff[40] >> 4] * (1.0f - fMixRate) + afLevelTable[(RxdBuff[40] >> 4) + 0x01U] * fMixRate;
	}
}

CBonBlackTuner::CBonBlackTuner(IBonObject *pOwner)
	: CBonTunerBase(pOwner, IDR_INISEQ_BLACK, IDR_ENDSEQ_BLACK, TEXT("CBonBlackTuner"))
{

}
