//////////////////////////////////////////////////////////////////////////
// BonSDK Friio (White/Black) tuner driver library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonEnumerator.h: FriiohCo񋓃NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Vector>


/////////////////////////////////////////////////////////////////////////////
// FriiohCo񋓃NX
/////////////////////////////////////////////////////////////////////////////

class CBonEnumerator
{
public:
	CBonEnumerator(void);
	virtual ~CBonEnumerator(void);

	const bool EnumDevice(const bool bBlackFriio = false);

	const DWORD GetTotalNum(void) const;
	const DWORD GetActiveNum(void) const;
	const DWORD GetAvailableNum(void) const;

	const CBonString LockAvailableDevice(DWORD &index);
	const bool ReleaseDevice(void);
	static const bool IsAvailableDevice(LPCTSTR lpszDriverPath);

protected:
	std::vector<CBonString> m_DriverList;
	CSmartMutex m_DeviceLock;
};
