//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// FileReader.h: t@C[_fR[_
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <Vector>
#include <Queue>


/////////////////////////////////////////////////////////////////////////////
// t@C[_fR[_
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: IMediaData	oCiXg[
/////////////////////////////////////////////////////////////////////////////

class CFileReader :	public CMediaDecoder,
					public IFileReader
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CFileReader)

// IFileReader
	virtual const bool OpenFile(LPCTSTR lpszFileName, const bool bAsyncRead = false, const DWORD dwBuffSize = 0UL);
	virtual bool CloseFile(void);
	virtual const DWORD ReadSync(const DWORD dwReadSize);
	virtual const bool SetReadPos(const ULONGLONG llPos);
	virtual const ULONGLONG GetReadPos(void);
	virtual const ULONGLONG GetFileLength(void);
	
// CFileReader
	CFileReader(IBonObject *pOwner);
	virtual ~CFileReader(void);
	
protected:
// CMediaDecoder
	virtual const bool OnPlay(void);
	virtual const bool OnStop(void);

// CFileReader
	void ReadThread(CSmartThread<CFileReader> &thread, const ISignal &bKillSignal, const ULONG_PTR param);
	void OutputThread(CSmartThread<CFileReader> &thread, const ISignal &bKillSignal, const ULONG_PTR param);
	
	virtual const DWORD ReadAsync(const DWORD dwReadSize);

	ISmartFile *m_pFile;
	CSmartThread<CFileReader> m_ReadThread;
	CSmartThread<CFileReader> m_OutputThread;

	std::vector<IMediaData *> m_MediaPool;
	std::vector<IMediaData *>::iterator m_itFreeMedia;
	std::queue<IMediaData *> m_MediaQue;

	DWORD m_dwBuffSize;
};
