//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// TsPacket.h: TSpPbgNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// ITsPacketNX
/////////////////////////////////////////////////////////////////////////////

class CTsPacket :	public CMediaData,
					public ITsPacket
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsPacket)

// ITsPacket
	virtual const DWORD ParsePacket(BYTE *pContinuityCounter = NULL);
	virtual BYTE * GetRawData(void);
	virtual const BYTE * GetRawData(void) const;
	virtual const WORD GetPID(void) const;
	virtual const bool IsScrambled(void) const;
	virtual const bool HaveAdaptationField(void) const;
	virtual BYTE * GetPayloadData(void);
	virtual const BYTE * GetPayloadData(void) const;
	virtual const BYTE GetPayloadSize(void) const;
	virtual const bool CopyPacket(const ITsPacket *pSrc);
	virtual const bool ComparePacket(const ITsPacket *pSrc) const;

// CMediaData
	virtual const DWORD CopyData(const IMediaData *pSrc);
	virtual IMediaData *Clone(IMediaDataHeap *pHeap = 0) const;

// CTsPacket
	CTsPacket(IBonObject *pOwner, IMediaDataHeap *pHeap = 0);
	virtual ~CTsPacket(void);
};
