//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// TsTableBase.h: PSIe[uNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "TsSection.h"


/////////////////////////////////////////////////////////////////////////////
// PSIe[uNX
/////////////////////////////////////////////////////////////////////////////

class CPsiTableBase :	public CBonObject,
						public ITsPidMapTarget,
						protected IPsiSectionParser::IHandler
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPsiTableBase)

// ITsPidMapTarget
	virtual const bool StorePacket(const ITsPacket *pTsPacket);
	virtual void OnPidReset(ITsPidMapper *pTsPidMapper, const WORD wPID);
	virtual void OnPidMapped(ITsPidMapper *pTsPidMapper, const WORD wPID);
	virtual void OnPidUnmapped(ITsPidMapper *pTsPidMapper, const WORD wPID);

// CPsiTableBase
	CPsiTableBase(IBonObject *pOwner);
	virtual ~CPsiTableBase(void);
	
	virtual void Reset(void);
	const DWORD GetCrcErrorCount(void) const;
	
protected:
// IPsiSectionParser::IHandler
	virtual void OnPsiSection(const IPsiSectionParser *pPsiSectionParser, const IPsiSection *pPsiSection);

// CPsiTableBase
	virtual const bool OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection);

	CPsiSectionParser m_SectionParser;
	CPsiSection m_LastSection;

	DWORD m_dwRefCount;
};
