//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT1 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// PtTriTuner.cpp: PT n/BS/110CS`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "PtTriTuner.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME_TRI	TEXT("Earthsoft PT1 ISDB-T/S fW^`[i")

// obt@ݒ
#define FIFOBUFFTIME	2UL												// obt@ = 2b
#define FIFOBLOCKSIZE	(4096UL * 511UL / 3UL)							// ubNTCY
#define FIFOBUFFNUM		(0x3C0000UL / FIFOBLOCKSIZE * FIFOBUFFTIME)		// 30MbpsƂ

// UHF `lݒ
static const CPtBaseTuner::PT_CH_CONFIG f_aConfigUHF[] =
{
	{ 63UL, 0x0000U},
	{ 64UL, 0x0000U},
	{ 65UL, 0x0000U},
	{ 66UL, 0x0000U},
	{ 67UL, 0x0000U},
	{ 68UL, 0x0000U},
	{ 69UL, 0x0000U},
	{ 70UL, 0x0000U},
	{ 71UL, 0x0000U},
	{ 72UL, 0x0000U},
	{ 73UL, 0x0000U},
	{ 74UL, 0x0000U},
	{ 75UL, 0x0000U},
	{ 76UL, 0x0000U},
	{ 77UL, 0x0000U},
	{ 78UL, 0x0000U},
	{ 79UL, 0x0000U},
	{ 80UL, 0x0000U},
	{ 81UL, 0x0000U},
	{ 82UL, 0x0000U},
	{ 83UL, 0x0000U},
	{ 84UL, 0x0000U},
	{ 85UL, 0x0000U},
	{ 86UL, 0x0000U},
	{ 87UL, 0x0000U},
	{ 88UL, 0x0000U},
	{ 89UL, 0x0000U},
	{ 90UL, 0x0000U},
	{ 91UL, 0x0000U},
	{ 92UL, 0x0000U},
	{ 93UL, 0x0000U},
	{ 94UL, 0x0000U},
	{ 95UL, 0x0000U},
	{ 96UL, 0x0000U},
	{ 97UL, 0x0000U},
	{ 98UL, 0x0000U},
	{ 99UL, 0x0000U},
	{100UL, 0x0000U},
	{101UL, 0x0000U},
	{102UL, 0x0000U},
	{103UL, 0x0000U},
	{104UL, 0x0000U},
	{105UL, 0x0000U},
	{106UL, 0x0000U},
	{107UL, 0x0000U},
	{108UL, 0x0000U},
	{109UL, 0x0000U},
	{110UL, 0x0000U},
	{111UL, 0x0000U},
	{112UL, 0x0000U}
};

// VHF `lݒ
static const CPtBaseTuner::PT_CH_CONFIG f_aConfigVHF[] =
{
	{ 0UL, 0x0000U},
	{ 1UL, 0x0000U},
	{ 2UL, 0x0000U},
	{13UL, 0x0000U},
	{14UL, 0x0000U},
	{15UL, 0x0000U},
	{16UL, 0x0000U},
	{17UL, 0x0000U},
	{18UL, 0x0000U},
	{19UL, 0x0000U},
	{20UL, 0x0000U},
	{21UL, 0x0000U}
};

// CATV `lݒ
static const CPtBaseTuner::PT_CH_CONFIG f_aConfigCATV[] =
{
	{ 3UL, 0x0000U},
	{ 4UL, 0x0000U},
	{ 5UL, 0x0000U},
	{ 6UL, 0x0000U},
	{ 7UL, 0x0000U},
	{ 8UL, 0x0000U},
	{ 9UL, 0x0000U},
	{10UL, 0x0000U},
	{11UL, 0x0000U},
	{12UL, 0x0000U},
	{22UL, 0x0000U},
	{23UL, 0x0000U},
	{24UL, 0x0000U},
	{25UL, 0x0000U},
	{26UL, 0x0000U},
	{27UL, 0x0000U},
	{28UL, 0x0000U},
	{29UL, 0x0000U},
	{30UL, 0x0000U},
	{31UL, 0x0000U},
	{32UL, 0x0000U},
	{33UL, 0x0000U},
	{34UL, 0x0000U},
	{35UL, 0x0000U},
	{36UL, 0x0000U},
	{37UL, 0x0000U},
	{38UL, 0x0000U},
	{39UL, 0x0000U},
	{40UL, 0x0000U},
	{41UL, 0x0000U},
	{42UL, 0x0000U},
	{43UL, 0x0000U},
	{44UL, 0x0000U},
	{45UL, 0x0000U},
	{46UL, 0x0000U},
	{47UL, 0x0000U},
	{48UL, 0x0000U},
	{49UL, 0x0000U},
	{50UL, 0x0000U},
	{51UL, 0x0000U},
	{52UL, 0x0000U},
	{53UL, 0x0000U},
	{54UL, 0x0000U},
	{55UL, 0x0000U},
	{56UL, 0x0000U},
	{57UL, 0x0000U},
	{58UL, 0x0000U},
	{59UL, 0x0000U},
	{60UL, 0x0000U},
	{61UL, 0x0000U},
	{62UL, 0x0000U}
};

// BS `lݒ		2008/10/12 
static const CPtBaseTuner::PT_CH_CONFIG f_aConfigBS[] =
{
	{0UL, 0x4010U},
	{0UL, 0x4011U},
	{1UL, 0x4030U},
	{1UL, 0x4031U},
	{4UL, 0x4090U},
	{4UL, 0x4091U},
	{4UL, 0x4092U},
	{6UL, 0x40D0U},
	{6UL, 0x40D1U},
	{7UL, 0x40F1U},
	{7UL, 0x40F2U}
};

// 110CS `lݒ		2008/10/12 
static const CPtBaseTuner::PT_CH_CONFIG f_aConfigCS[] =
{
	{12UL, 0x6020U},
	{13UL, 0x7040U},
	{14UL, 0x7060U},
	{15UL, 0x6080U},
	{16UL, 0x60A0U},
	{17UL, 0x70C0U},
	{18UL, 0x70E0U},
	{19UL, 0x7100U},
	{20UL, 0x7120U},
	{21UL, 0x7140U},
	{22UL, 0x7160U},
	{23UL, 0x7180U}
};

// `lԐݒ
static const CPtBaseTuner::PT_CH_SPACE f_aChSpace[] =
{
	{f_aConfigUHF,  sizeof(f_aConfigUHF)  / sizeof(*f_aConfigUHF) },
	{f_aConfigVHF,  sizeof(f_aConfigVHF)  / sizeof(*f_aConfigVHF) },
	{f_aConfigCATV, sizeof(f_aConfigCATV) / sizeof(*f_aConfigCATV)},
	{f_aConfigBS,   sizeof(f_aConfigBS)   / sizeof(*f_aConfigBS)  },
	{f_aConfigCS,   sizeof(f_aConfigCS)   / sizeof(*f_aConfigCS)  }
};


/////////////////////////////////////////////////////////////////////////////
// PT BS/110CS`[iNX
/////////////////////////////////////////////////////////////////////////////

const CBonString CPtTriTuner::GetDeviceName() const
{
	static const CBonString deviceName(DEVICENAME_TRI);

	// foCXԂ
	return deviceName;
}

const DWORD CPtTriTuner::GetTotalDeviceNum(void) const
{
	// `[ȋԂ
	const DWORD dwSatTunerNum = m_pPtManager->GetTotalTunerNum(Device::ISDB_S);
	const DWORD dwTerTunerNum = m_pPtManager->GetTotalTunerNum(Device::ISDB_T);

	// ȂԂ
	return (dwSatTunerNum <= dwTerTunerNum)? dwSatTunerNum : dwTerTunerNum;
}

const DWORD CPtTriTuner::GetActiveDeviceNum(void) const
{
	// gp̃`[iԂ
	const DWORD dwSatTunerNum = m_pPtManager->GetActiveTunerNum(Device::ISDB_S);
	const DWORD dwTerTunerNum = m_pPtManager->GetActiveTunerNum(Device::ISDB_T);

	// Ԃ
	return (dwSatTunerNum >= dwTerTunerNum)? dwSatTunerNum : dwTerTunerNum;
}

const DWORD CPtTriTuner::OpenTuner(void)
{
	try{
		// ISDB-T`[iI[v
		DWORD result = CPtBaseTuner::OpenTuner();
		if(result != EC_OPEN_SUCCESS)throw ::BON_EXPECTION(TEXT("ISDB-T`[iI[vs"));
		
		// Jg`[iZbg
		m_apTuner[Device::ISDB_T] = m_pTuner;

		// ISDB-S`[iI[v
		if(!(m_apTuner[Device::ISDB_S] = m_pPtManager->OpenTuner(Device::ISDB_S)))throw ::BON_EXPECTION(TEXT("ISDB-S`[iI[vs"));
		
		// LNBdݒ
		if(!m_apTuner[Device::ISDB_S]->SetLnbPower(m_Property.m_bDefaultLnbPower))throw ::BON_EXPECTION(TEXT("LNBdݒ莸s"));
		}
	catch(const CBonException &){
		// G[
		CloseTuner();
		return EC_OPEN_FAILED;
		}
	
	return EC_OPEN_SUCCESS;
}

void CPtTriTuner::CloseTuner(void)
{
	// `[iN[Y
	for(DWORD dwIndex = 0UL ; dwIndex < (sizeof(m_apTuner) / sizeof(*m_apTuner)) ; dwIndex++){
		if(m_apTuner[dwIndex]){
			m_apTuner[dwIndex]->StopStream();
			m_apTuner[dwIndex]->CloseTuner();
			m_apTuner[dwIndex] = NULL;
			}		
		}
	
	// Jg`[iNA
	m_pTuner = NULL;
	
	// FIFOobt@J
	CPtBaseTuner::CloseTuner();
}

const CBonString CPtTriTuner::EnumTuningSpace(const DWORD dwSpace) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_UHF);
	case 1:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_VHF);
	case 2:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_CATV);
	case 3:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_BS);
	case 4:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_CS110);
	}
	return CBonString::GetEmpty();
}

const CBonString CPtTriTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_UHF, dwChannel);
	case 1:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_VHF, dwChannel);
	case 2:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_CATV, dwChannel);
	case 3:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_BS, dwChannel);
	case 4:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_CS110, dwChannel);
	}
	return CBonString::GetEmpty();
}

const bool CPtTriTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!m_pTuner || EnumChannelName(dwSpace, dwChannel).IsEmpty())return false;

	// `[jONGXgɑ΂`[iCX^X
	CPtTuner *pReqTuner = (m_TuningSpace[dwSpace]->pChConfig[dwChannel].wTsID)? m_apTuner[Device::ISDB_S] : m_apTuner[Device::ISDB_T];

	if(pReqTuner && (m_pTuner != pReqTuner)){
		// Jg`[iXg[M~
		m_pTuner->StopStream();
		
		// NGXg`[iXg[MJn
		if(!pReqTuner->StartStream(this))return false;
		
		// Jg`[iXV
		m_pTuner = pReqTuner;
		}

	// `lݒ
	if(!m_pTuner->SetChannel(m_TuningSpace[dwSpace]->pChConfig[dwChannel].dwChIndex))return false;

	// TS IDݒ
	if(m_TuningSpace[dwSpace]->pChConfig[dwChannel].wTsID){
		if(!m_pTuner->SetTsID(m_TuningSpace[dwSpace]->pChConfig[dwChannel].wTsID))return false;
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	return true;
}

const bool CPtTriTuner::SetLnbPower(const bool bEnable)
{
	// LNBdԐݒ
	return (m_apTuner[Device::ISDB_S])? m_apTuner[Device::ISDB_S]->SetLnbPower(bEnable) : false;
}

const bool CPtTriTuner::SetProperty(const IConfigProperty *pProperty)
{
	bool bReturn = CPtBaseTuner::SetProperty(pProperty);

	// `[jOԍĐݒ
	m_TuningSpace.clear();

	m_TuningSpace.push_back(&f_aChSpace[0]);							// UHF
	if(m_Property.m_bEnableVHF )m_TuningSpace.push_back(&f_aChSpace[1]);	// VHF
	if(m_Property.m_bEnableCATV)m_TuningSpace.push_back(&f_aChSpace[2]);	// CATV
	if(m_Property.m_bEnableBS  )m_TuningSpace.push_back(&f_aChSpace[3]);	// BS
	if(m_Property.m_bEnableCS  )m_TuningSpace.push_back(&f_aChSpace[4]);	// CS

	return bReturn;
}

CPtTriTuner::CPtTriTuner(IBonObject *pOwner)
	: CPtBaseTuner(pOwner, Device::ISDB_T)
{
	// `[iCX^X
	for(DWORD dwIndex = 0UL ; dwIndex < (sizeof(m_apTuner) / sizeof(*m_apTuner)) ; dwIndex++){
		m_apTuner[dwIndex] = NULL;
		}
		
	// `[jOԏݒ
	SetProperty(NULL);
}

CPtTriTuner::~CPtTriTuner(void)
{
	// Ȃ
}

void CPtTriTuner::OnTsStream(CPtTuner *pTuner, const BYTE *pData, const DWORD dwSize)
{
	// Jg`[iɈvXg[̂ݏo
	if(m_pTuner == pTuner){
		CPtBaseTuner::OnTsStream(pTuner, pData, dwSize);
		}
}
