//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT1 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// PtTriTuner.h: PT n/BS/110CS`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "PtBaseTuner.h"



/////////////////////////////////////////////////////////////////////////////
// PT n/BS/110CS`[iNX
/////////////////////////////////////////////////////////////////////////////

class CPtTriTuner :	public CPtBaseTuner
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPtTriTuner)

// CPtBaseTuner(IHalDevice)
	virtual const CBonString GetDeviceName() const;
	virtual const DWORD GetTotalDeviceNum(void) const;
	virtual const DWORD GetActiveDeviceNum(void) const;

// CPtBaseTuner(IHalTsTuner)
	virtual const DWORD OpenTuner(void);
	virtual void CloseTuner(void);

	virtual const CBonString EnumTuningSpace(const DWORD dwSpace) const;
	virtual const CBonString EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const;
	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	virtual const bool SetLnbPower(const bool bEnable);

// IConfigTarget
	virtual const bool SetProperty(const IConfigProperty *pProperty);

// CPtSatTuner
	CPtTriTuner(IBonObject *pOwner);
	virtual ~CPtTriTuner(void);

protected:
	virtual void OnTsStream(CPtTuner *pTuner, const BYTE *pData, const DWORD dwSize);

	CPtTuner *m_apTuner[Device::ISDB_COUNT];
};
