//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// Pt2SatTuner.cpp: PT2 BS/110CS`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "Pt2SatTuner.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// BS `lݒ		2008/10/12 
static const CPt2BaseTuner::PT_CH_CONFIG f_aConfigBS[] =
{
	{0UL, 0x4010U},
	{0UL, 0x4011U},
	{1UL, 0x4030U},
	{1UL, 0x4031U},
	{4UL, 0x4090U},
	{4UL, 0x4091U},
	{4UL, 0x4092U},
	{6UL, 0x40D0U},
	{6UL, 0x40D1U},
	{7UL, 0x40F1U},
	{7UL, 0x40F2U}
};

// 110CS `lݒ		2008/10/12 
static const CPt2BaseTuner::PT_CH_CONFIG f_aConfigCS[] =
{
	{12UL, 0x6020U},
	{13UL, 0x7040U},
	{14UL, 0x7060U},
	{15UL, 0x6080U},
	{16UL, 0x60A0U},
	{17UL, 0x70C0U},
	{18UL, 0x70E0U},
	{19UL, 0x7100U},
	{20UL, 0x7120U},
	{21UL, 0x7140U},
	{22UL, 0x7160U},
	{23UL, 0x7180U}
};

// `lԐݒ
static const CPt2BaseTuner::PT_CH_SPACE f_aChSpace[] =
{
	{f_aConfigBS, sizeof(f_aConfigBS) / sizeof(*f_aConfigBS)},
	{f_aConfigCS, sizeof(f_aConfigCS) / sizeof(*f_aConfigCS)}
};


/////////////////////////////////////////////////////////////////////////////
// PT2 BS/110CS`[iNX
/////////////////////////////////////////////////////////////////////////////

const CBonString CPt2SatTuner::EnumTuningSpace(const DWORD dwSpace) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_BS);
	case 1:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_CS110);
	}
	return CBonString::GetEmpty();
}

const CBonString CPt2SatTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_BS, dwChannel);
	case 1:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_CS110, dwChannel);
	}
	return CBonString::GetEmpty();
}

const bool CPt2SatTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!m_pTuner || EnumChannelName(dwSpace, dwChannel).IsEmpty())return false;

	// `lݒ
	if(!m_pTuner->SetChannel(m_TuningSpace[dwSpace]->pChConfig[dwChannel].dwChIndex))return false;

	// TS IDݒ
	if(!m_pTuner->SetTsID(m_TuningSpace[dwSpace]->pChConfig[dwChannel].wTsID))return false;

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	return true;
}

const bool CPt2SatTuner::SetProperty(const IConfigProperty *pProperty)
{
	bool bReturn = CPt2BaseTuner::SetProperty(pProperty);

	// `[jOԍĐݒ
	m_TuningSpace.clear();
	
	if(m_Property.m_bEnaleBS)m_TuningSpace.push_back(&f_aChSpace[0]);	// BS
	if(m_Property.m_bEnaleCS)m_TuningSpace.push_back(&f_aChSpace[1]);	// CS

	return bReturn;
}

CPt2SatTuner::CPt2SatTuner(IBonObject *pOwner)
	: CPt2BaseTuner(pOwner, Device::ISDB_S)
{
	// `[jOԏݒ
	SetProperty(NULL);
}

CPt2SatTuner::~CPt2SatTuner(void)
{
	// Ȃ
}
