//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// Pt2TerTuner.cpp: PT2ng`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "Pt2TerTuner.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// UHF `lݒ
static const CPt2BaseTuner::PT_CH_CONFIG f_aConfigUHF[] =
{
	{ 63UL, 0x0000U},
	{ 64UL, 0x0000U},
	{ 65UL, 0x0000U},
	{ 66UL, 0x0000U},
	{ 67UL, 0x0000U},
	{ 68UL, 0x0000U},
	{ 69UL, 0x0000U},
	{ 70UL, 0x0000U},
	{ 71UL, 0x0000U},
	{ 72UL, 0x0000U},
	{ 73UL, 0x0000U},
	{ 74UL, 0x0000U},
	{ 75UL, 0x0000U},
	{ 76UL, 0x0000U},
	{ 77UL, 0x0000U},
	{ 78UL, 0x0000U},
	{ 79UL, 0x0000U},
	{ 80UL, 0x0000U},
	{ 81UL, 0x0000U},
	{ 82UL, 0x0000U},
	{ 83UL, 0x0000U},
	{ 84UL, 0x0000U},
	{ 85UL, 0x0000U},
	{ 86UL, 0x0000U},
	{ 87UL, 0x0000U},
	{ 88UL, 0x0000U},
	{ 89UL, 0x0000U},
	{ 90UL, 0x0000U},
	{ 91UL, 0x0000U},
	{ 92UL, 0x0000U},
	{ 93UL, 0x0000U},
	{ 94UL, 0x0000U},
	{ 95UL, 0x0000U},
	{ 96UL, 0x0000U},
	{ 97UL, 0x0000U},
	{ 98UL, 0x0000U},
	{ 99UL, 0x0000U},
	{100UL, 0x0000U},
	{101UL, 0x0000U},
	{102UL, 0x0000U},
	{103UL, 0x0000U},
	{104UL, 0x0000U},
	{105UL, 0x0000U},
	{106UL, 0x0000U},
	{107UL, 0x0000U},
	{108UL, 0x0000U},
	{109UL, 0x0000U},
	{110UL, 0x0000U},
	{111UL, 0x0000U},
	{112UL, 0x0000U}
};

// VHF `lݒ
static const CPt2BaseTuner::PT_CH_CONFIG f_aConfigVHF[] =
{
	{ 0UL, 0x0000U},
	{ 1UL, 0x0000U},
	{ 2UL, 0x0000U},
	{13UL, 0x0000U},
	{14UL, 0x0000U},
	{15UL, 0x0000U},
	{16UL, 0x0000U},
	{17UL, 0x0000U},
	{18UL, 0x0000U},
	{19UL, 0x0000U},
	{20UL, 0x0000U},
	{21UL, 0x0000U}
};

// CATV `lݒ
static const CPt2BaseTuner::PT_CH_CONFIG f_aConfigCATV[] =
{
	{ 3UL, 0x0000U},
	{ 4UL, 0x0000U},
	{ 5UL, 0x0000U},
	{ 6UL, 0x0000U},
	{ 7UL, 0x0000U},
	{ 8UL, 0x0000U},
	{ 9UL, 0x0000U},
	{10UL, 0x0000U},
	{11UL, 0x0000U},
	{12UL, 0x0000U},
	{22UL, 0x0000U},
	{23UL, 0x0000U},
	{24UL, 0x0000U},
	{25UL, 0x0000U},
	{26UL, 0x0000U},
	{27UL, 0x0000U},
	{28UL, 0x0000U},
	{29UL, 0x0000U},
	{30UL, 0x0000U},
	{31UL, 0x0000U},
	{32UL, 0x0000U},
	{33UL, 0x0000U},
	{34UL, 0x0000U},
	{35UL, 0x0000U},
	{36UL, 0x0000U},
	{37UL, 0x0000U},
	{38UL, 0x0000U},
	{39UL, 0x0000U},
	{40UL, 0x0000U},
	{41UL, 0x0000U},
	{42UL, 0x0000U},
	{43UL, 0x0000U},
	{44UL, 0x0000U},
	{45UL, 0x0000U},
	{46UL, 0x0000U},
	{47UL, 0x0000U},
	{48UL, 0x0000U},
	{49UL, 0x0000U},
	{50UL, 0x0000U},
	{51UL, 0x0000U},
	{52UL, 0x0000U},
	{53UL, 0x0000U},
	{54UL, 0x0000U},
	{55UL, 0x0000U},
	{56UL, 0x0000U},
	{57UL, 0x0000U},
	{58UL, 0x0000U},
	{59UL, 0x0000U},
	{60UL, 0x0000U},
	{61UL, 0x0000U},
	{62UL, 0x0000U}
};

// `lԐݒ
static const CPt2BaseTuner::PT_CH_SPACE f_aChSpace[] =
{
	{f_aConfigUHF,  sizeof(f_aConfigUHF)  / sizeof(*f_aConfigUHF) },
	{f_aConfigVHF,  sizeof(f_aConfigVHF)  / sizeof(*f_aConfigVHF) },
	{f_aConfigCATV, sizeof(f_aConfigCATV) / sizeof(*f_aConfigCATV)}
};


/////////////////////////////////////////////////////////////////////////////
// PTng`[iNX
/////////////////////////////////////////////////////////////////////////////

const CBonString CPt2TerTuner::EnumTuningSpace(const DWORD dwSpace) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_UHF);
	case 1:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_VHF);
	case 2:
		return GetStandardTuningSpaceName(IStandardTuningSpace::TUNING_SPACE_CATV);
	}
	return CBonString::GetEmpty();
}

const CBonString CPt2TerTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	switch (dwSpace)
	{
	case 0:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_UHF, dwChannel);
	case 1:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_VHF, dwChannel);
	case 2:
		return GetStandardChannelName(IStandardTuningSpace::TUNING_SPACE_CATV, dwChannel);
	}
	return CBonString::GetEmpty();
}

const bool CPt2TerTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!m_pTuner || EnumChannelName(dwSpace, dwChannel).IsEmpty())return false;

	// `lݒ
	if(!m_pTuner->SetChannel(m_TuningSpace[dwSpace]->pChConfig[dwChannel].dwChIndex))return false;

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	return true;
}

const bool CPt2TerTuner::SetProperty(const IConfigProperty *pProperty)
{
	bool bReturn = CPt2BaseTuner::SetProperty(pProperty);

	// `[jOԍĐݒ
	m_TuningSpace.clear();
	
	m_TuningSpace.push_back(&f_aChSpace[0]);							// UHF
	if(m_Property.m_bEnaleVHF )m_TuningSpace.push_back(&f_aChSpace[1]);	// VHF
	if(m_Property.m_bEnaleCATV)m_TuningSpace.push_back(&f_aChSpace[2]);	// CATV
	
	return bReturn;
}

CPt2TerTuner::CPt2TerTuner(IBonObject *pOwner)
	: CPt2BaseTuner(pOwner, Device::ISDB_T)
{
	// `[jOԏݒ
	SetProperty(NULL);
}

CPt2TerTuner::~CPt2TerTuner(void)
{
	// Ȃ
}
