//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// Pt2TriTuner.h: PT2 n/BS/110CS`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "Pt2BaseTuner.h"



/////////////////////////////////////////////////////////////////////////////
// PT2 n/BS/110CS`[iNX
/////////////////////////////////////////////////////////////////////////////

class CPt2TriTuner :	public CPt2BaseTuner
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPt2TriTuner)

// CPtBaseTuner(IHalDevice)
	virtual const CBonString GetDeviceName() const;
	virtual const DWORD GetTotalDeviceNum(void) const;
	virtual const DWORD GetActiveDeviceNum(void) const;

// CPt2BaseTuner(IHalTsTuner)
	virtual const DWORD OpenTuner(void);
	virtual void CloseTuner(void);

	virtual const CBonString EnumTuningSpace(const DWORD dwSpace) const;
	virtual const CBonString EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const;
	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	virtual const bool SetLnbPower(const bool bEnable);

// IConfigTarget
	virtual const bool SetProperty(const IConfigProperty *pProperty);

// CPt2SatTuner
	CPt2TriTuner(IBonObject *pOwner);
	virtual ~CPt2TriTuner(void);

protected:
	virtual void OnTsStream(CPt2Tuner *pTuner, const BYTE *pData, const DWORD dwSize);

	CPt2Tuner *m_apTuner[Device::ISDB_COUNT];
};
